<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on August 22, 2008 at 12:14:33 pm</time-stamp>
<!-- Changes from: PV-Datachannel(Kila.279,sourcecontrol)  to: PV-Datachannel(Kila.279.12,jhylands) -->


<methods>
<class-id>Core.Boolean</class-id> <category>Smee</category>

<body package="Smee-Primitive Values" selector="smeeSumFromString:">smeeSumFromString: aString
	^self smeeToNumber smeeSumFromString: aString</body>
</methods>



<methods>
<class-id>Core.Collection</class-id> <category>parameters</category>

<body package="PV-Base Extensions" selector="asParameterListString">asParameterListString
	
	^String streamContents: 
		[:out | 
		out nextPut: $(.
		self 
			do: [:each | out print: each]
			separatedBy: [out nextPutAll: ','].
		out nextPut: $)]</body>
</methods>


<class>
<name>PvLinuxSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvUnixSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvLinuxSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libc.so</item> <item>libprovisodc.so</item></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/mkamath/Kila.279</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseKila/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<class>
<name>PvSystemSupport</name>
<environment>PROVISO</environment>
<super>External.ExternalInterface</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles></includeFiles>
<includeDirectories></includeDirectories>
<libraryFiles></libraryFiles>
<libraryDirectories><item>d:\Proviso\development\Kila</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.SharedPriorityQueue</class-id> <category>access operations</category>

<body package="PV-Base Extensions" selector="contents">contents
	"&lt;OrderedCollection&gt; Answer the contents of the queue" 

	^[accessProtect critical: [contents copy]] valueUninterruptably</body>
</methods>


<methods>
<class-id>Core.Symbol</class-id> <category>accessing</category>

<body package="PV-Base Extensions" selector="findNextUnusedMessageIdForDC">findNextUnusedMessageIdForDC
	"DC messages start at 10000"
	^#DC10000 privateFindNextUnusedMessageId</body>

<body package="PV-Base Extensions" selector="privateFindNextUnusedMessageId">privateFindNextUnusedMessageId
	"
	#DC10000 privateFindNextUnusedMessageId
	#DL39000 privateFindNextUnusedMessageId
	"

	| firstNum letters number |
	firstNum := (1 to: self size) detect: [ :i | (self at: i) isDigit] ifNone: [(self size + 1)].
	letters := self copyFrom: 1 to: (firstNum - 1).
	number := (self copyFrom: firstNum to: self size) asNumber.

	[(Symbol findInterned: (letters, number asString)) ifNil: [^(letters, number asString)].
	number := number + 1] repeat.</body>

<body package="PV-Base Extensions" selector="findNextUnusedMessageIdForDL">findNextUnusedMessageIdForDL
	"DL messages start at 39000"

	^#DL39000 privateFindNextUnusedMessageId</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.Core.Symbol</class-id> <selector>findNextUnusedMessageId</selector>
</remove-selector>

<class>
<name>PvWindowsSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvWindowsSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>windef.h</item> <item>winnt.h</item> <item>winbase.h</item> <item>process.h</item></includeFiles>
<includeDirectories><item>d:\program files\microsoft visual studio\vc98\include</item></includeDirectories>
<libraryFiles><item>kernel32.dll</item></libraryFiles>
<libraryDirectories><item>d:\Proviso\development\Kila</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>


<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>writing</category>

<body package="PV-Support" selector="writeFormulaOperator:">writeFormulaOperator: aFormulaOperator

    | args count |
    self write: aFormulaOperator periodStart.
    self write: aFormulaOperator lastTuple.
    self write: aFormulaOperator inputs.
    
    "Write property state"
    args := aFormulaOperator smeePrototype arguments.
    count := 0.
"
    aFormulaOperator smeeProperties do: [:assn | 
        name := assn key.
        ((args anySatisfy: [:eachArg | eachArg name = name])
            or: [#(startOfPeriod prototype emitValue emitTuple duration downtime) includes: name])
                ifFalse: [count := count + 1]].
"
    self writeVarInt: (self idForClass: OrderedCollection).
    self writeSize: count.
" 
   aFormulaOperator smeeProperties do: [:assn | 
        name := assn key.
        ((args anySatisfy: [:eachArg | eachArg name = name])
            or: [#(startOfPeriod prototype emitValue emitTuple duration downtime) includes: name])
                ifFalse: [self write: assn]].
"</body>
</methods>



<methods>
<class-id>PROVISO.PvDbSqlStatement</class-id> <category>control</category>

<body package="PV-DB-Support" selector="resetAnswer">resetAnswer
	
	promise := Promise new.
	self critical: 
		[self isAnswered 
			ifTrue: 
				[dbSession answer isSymbol 
					ifFalse: 
						[[dbSession answer close] 
							on: 
								Error , SystemNotification , 
									ExternalDatabaseConnection externalDatabaseInformationSignal
							do: 
								[:error | 
								self system 
									logDebugThree: #CLOSE_FAILED
									text: error messageText]].
				self state: self statePrepared]
			ifFalse: 
				[self system 
					logDebugThree: #COULDNT_CLOSE
					text: self state printString]]</body>
</methods>



<methods>
<class-id>PROVISO.PvEventType class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString

	^'
Select /*+ PUSH_SUBQ */
       %columnList 
  From %eventTypeHistory evt
 Where evt.Dte_Date %resyncDateCondition
   And evt.Dte_Date = (Select Max(evt1.Dte_Date)
                         From %eventTypeHistory evt1
                        Where evt1.Idx_Ind = evt.Idx_Ind
                          And evt1.Dte_Date %resyncDateCondition )
   And evt.Str_Action In %actionList;
'</body>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventTypeHistory' put: self historyTableName asString.
	namedReplacements at: 'columnList' put: (self allColumnsForSelectWithPrefix: 'evt.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvInputBuildCommand class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementForAllForMsid:between:and:">selectStatementForAllForMsid: operator between: startSeconds and: endSeconds 
	"self selectAllForMsid: 210098240 between: 1211218765 and: 1214870399"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements   |
	realStartSeconds := startSeconds.
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.').
	operator notNil
		ifTrue: [
			namedReplacements 
				at: 'OPERATORCLAUSE'
				put: 't1.idx_ts_operator = ', operator asString].

	endSeconds == Infinity positive
		ifTrue: [namedReplacements at: 'PRIMARYDATECONDITION' put: ' &gt;= ' , startSeconds asString , ' ']
		ifFalse: [
			startSeconds &gt; 0 
				ifTrue: [
					namedReplacements at: 'PRIMARYDATECONDITION' put: 
						' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
				ifFalse: [namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt;= ' , endSeconds asString , ' ']].

	^'SELECT 
		%COLUMNLIST 
	FROM  %TABLE t1
	WHERE %OPERATORCLAUSE
		AND t1.dte_date %PRIMARYDATECONDITION ' namedBindWithArguments: namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvTimeSeriesBuildCommand class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="bindVariableSelectStatementForLabelForMetricId:subelementId:between:and:">bindVariableSelectStatementForLabelForMetricId: metricId 
	subelementId: subelementId
	between: beginTimestamp
	and: endTimestamp
	"self bindVariableSelectStatementForLabelForMetricId: 1234 subelementId: 4567 between: 5000 and: 1000"

	| bindVariableArray |

	bindVariableArray := Array new: 4.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.
	bindVariableArray at: 3 put: beginTimestamp.
	bindVariableArray at: 4 put: endTimestamp.

	^ 'SELECT distinct ts1.int_label
         FROM ts_desc ts1
         WHERE ts1.idx_metric = :1 and ts1.idx_resource = :2 
           AND ts1.DTE_DATE = ( SELECT MAX(ts2.DTE_DATE)
                                FROM ts_desc ts2
                               WHERE ts1.idx_ind=ts2.idx_ind
                                 AND ts2.DTE_DATE between :3 and :4 )'
		-&gt; bindVariableArray</body>
</methods>

<methods>
<class-id>PROVISO.PvTimeSeriesBuildCommand class</class-id> <category>instance creation</category>

<body package="PV-DM-Support" selector="fromTimeSeries:">fromTimeSeries: aTimeSeries

	| inst |
	inst := self new
		msid: aTimeSeries msid;
		metricId: aTimeSeries metricId;
		resourceId: aTimeSeries resourceId; 
		resyncHistoricalDate: ([aTimeSeries timestamp] on: Error do: [:ex | nil]);
		resyncAction: #I;
		streamLabelId: aTimeSeries streamLabel;
		isExplicitAsNumber: aTimeSeries isExplicit;
		requestId: aTimeSeries requestId.
	inst versionDate: inst timestamp.
	^inst</body>
</methods>


<methods>
<class-id>PROVISO.PvEventProperty</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="postInsertUpdateIn:">postInsertUpdateIn: aPvModel 
	
	(self pvModel eventPropertyManager eventAttrTypes 
		at: self attributeId
		ifAbsent: [nil]) ifNotNil: 
			[:type | 
			self attrType ifNil: [self attrType: type].
			self name ifNil: [self name: type name]]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventProperty</class-id> <selector>setNameFromType:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvEventProperty class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventPropertyHistory' put: self historyTableName asString.
	namedReplacements at: 'eventHistory' put: PvEvent historyTableName asString.
	namedReplacements at: 'elementHistory' put: PvElement historyTableName asString.
	namedReplacements at: 'subelementHistory' put: 
		PvSubelement historyTableName asString.
	namedReplacements at: 'columnList' put: 
		(self allHistoricalColumnsForSelectWithPrefix: 'evav.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addToNowDateConditionTo: namedReplacements
			using: parametersDictionary;
		addCollectorClauseNamed: 'eCollectorClause'
			to: namedReplacements
			prefix: 'e'
			using: parametersDictionary;
		addCollectorClauseNamed: 'edCollectorClause'
			to: namedReplacements
			prefix: 'e1'
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString

	^'
Select /*+ ORDERED PUSH_SUBQ USE_NL(ev1 evav) */
       %columnList 
  From (Select /*+ NO_MERGE PUSH_SUBQ ORDERED USE_NL(se ev) INDEX(ev ID_EVDH_4_2) */
               ev.Idx_Ind
          From ( Select /*+ ORDERED NO_MERGE PUSH_SUBQ USE_NL(e s) */
                        s.Idx_Ind
                   From %elementHistory e,
                        %subelementHistory s
                  Where %eCollectorClause
                    s.Idx_Host = e.Idx_Ind
                    And e.Dte_Date %toNowDateCondition
                    And e.Dte_Date = ( Select Max(Dte_Date)
                                         From %elementHistory e1
                                        Where e1.Idx_Ind = e.Idx_Ind
                                          And %edCollectorClause
                                          e1.Dte_Date %toNowDateCondition )
                    And s.Dte_Date %toNowDateCondition
                    And s.Dte_Date = ( Select Max(Dte_Date)
                                         From %subelementHistory s1
                                        Where s1.Idx_Ind = s.Idx_Ind
                                          And s1.Dte_Date %toNowDateCondition )
                    And e.Str_Action In %actionList
                    And s.Str_Action In %actionList ) se,
               %eventHistory ev
         Where ev.Idx_Resource = se.Idx_Ind
           And ev.Dte_Date  %toNowDateCondition
           And ev.Dte_Date = (Select Max(ev1.Dte_Date)
                                From %eventHistory ev1
                               Where ev1.Idx_Ind = ev.Idx_Ind
                                 And ev1.Idx_Resource = ev.Idx_Resource
                                 And ev1.Dte_Date %toNowDateCondition )
           And ev.Str_Action In %actionList) ev1,
       %eventPropertyHistory evav
 Where evav.Idx_Event = ev1.Idx_Ind
   And evav.Dte_Date %resyncDateCondition
   And evav.Dte_Date = ( Select Max(evav1.Dte_Date)
                           From %eventPropertyHistory evav1
                          Where evav1.Idx_Event = evav.Idx_Event
                            And evav1.Idx_Attribute = evav.Idx_Attribute
                            And evav1.Dte_Date %resyncDateCondition )
   And evav.Str_Action In %actionList;
'</body>
</methods>


<class>
<name>PVDatabaseDomainHelper</name>
<environment>PROVISO</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>Root.Smalltalk.PROVISO.PVDatabaseDomainHelper</class-id> <category>parameters</category>

<body package="PV-DM-Support" selector="addCollectorClauseNamed:to:prefix:using:">addCollectorClauseNamed: name
	to: namedReplacements
	prefix: prefix
	using: parametersDictionary
	
	| collectors |
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [#()].
	namedReplacements 
		at: name
		put: 
			(collectors isEmpty 
				ifTrue: ['']
				ifFalse: 
					[prefix , '.Int_Collector In ' , collectors asParameterListString , ' And '])</body>

<body package="PV-DM-Support" selector="addActionListTo:using:">addActionListTo: namedReplacements using: parametersDictionary 
	
	| startSeconds |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	namedReplacements 
		at: 'actionList'
		put: 
			(startSeconds &gt; 0 
				ifTrue: [#('I' 'U' 'D')]
				ifFalse: [#('I' 'U')]) asParameterListString</body>

<body package="PV-DM-Support" selector="addToNowDateConditionTo:using:">addToNowDateConditionTo: namedReplacements using: parametersDictionary 
	
	| endSeconds |
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	namedReplacements at: 'toNowDateCondition' put: ' &lt;= ' , endSeconds asString , ' '</body>

<body package="PV-DM-Support" selector="addResyncDateConditionTo:using:">addResyncDateConditionTo: namedReplacements using: parametersDictionary 
	
	| endSeconds startSeconds |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	namedReplacements 
		at: 'resyncDateCondition'
		put: 
			(startSeconds &gt; 0 
				ifTrue: [' BETWEEN ' , startSeconds asString , ' AND ' , endSeconds asString , ' ']
				ifFalse: [' &lt;= ' , endSeconds asString , ' '])</body>
</methods>


<methods>
<class-id>PROVISO.PvFormula</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="dependsOnFormula:">dependsOnFormula: aPvFormula 
 
	^self formulaPrototype 
		ifNil: [false]
		ifNotNil: 
			[:f | 
			self isSmee and: 
				[f arguments notNil and: 
					[f arguments anySatisfy: 
						[:eachArg | 
						eachArg pathFormulas notNil and: 
							[eachArg pathFormulas anySatisfy: 
								[:eachAssoc | 
								eachAssoc value notNil and: 
									[eachAssoc value == aPvFormula or: [eachAssoc value dependsOnFormula: aPvFormula]]]]]]]]</body>
</methods>

<methods>
<class-id>PROVISO.PvFormula</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="addSpecificFormula:">addSpecificFormula: aFormula

	self specificFormulas ifNil: [self specificFormulas: Set new].
	self specificFormulas add: aFormula</body>

<body package="PV-DM-Support" selector="resetSpecificFormulas">resetSpecificFormulas

	self specificFormulas: nil</body>
</methods>


<methods>
<class-id>PROVISO.PvAbstractPlanBuildCommand</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="isSameAs:">isSameAs: anotherCommand 
	
	^self resyncHistoricalDate = anotherCommand resyncHistoricalDate and: 
		[self resyncAction = anotherCommand resyncAction and: 
			[self versionDate = anotherCommand versionDate]]</body>
</methods>


<methods>
<class-id>PROVISO.PvAbstractDomainObjectVisitor</class-id> <category>visitor-callbacks</category>

<body package="PV-DM-Support" selector="acceptModel:">acceptModel: aPvModel 
	
	self 
		visit: aPvModel elementManager;
		visit: aPvModel subelementManager;
		visit: aPvModel propertyManager;
		visit: aPvModel relationManager;
		visit: aPvModel thresholdManager;
		visit: aPvModel calendarManager;
		visit: aPvModel requestManager;
		visit: aPvModel eventManager;
		visit: aPvModel eventPropertyManager;
		visit: aPvModel eventRelationManager</body>
</methods>


<methods>
<class-id>PROVISO.PvEventAttrType class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventAttributeTypeHistory' put: self historyTableName asString.
	namedReplacements at: 'columnList' put: 
		(self allColumnsForSelectWithPrefix: 'evad.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString

	^'
Select /*+ PUSH_SUBQ */
       %columnList 
  From %eventAttributeTypeHistory evad
 Where evad.Dte_Date %resyncDateCondition
   And evad.Dte_Date = (Select Max(evad1.Dte_Date)
                          From %eventAttributeTypeHistory evad1
                         Where evad1.Idx_Ind = evad.Idx_Ind
                           And evad1.Dte_Date %resyncDateCondition )
   And evad.Str_Action In %actionList;
'</body>
</methods>


<methods>
<class-id>PROVISO.PvThresholdDefinition class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementForFormulaId:">selectStatementForFormulaId: formulaId

	^'select idx_metric from ', self tableName, ' where idx_metric = ', formulaId printString</body>
</methods>


<class>
<name>PvEvent</name>
<environment>PROVISO</environment>
<super>PROVISO.PvGroupableObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>type origin username properties subelement subelementId date eventType eventTypeId relations </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>initialize-release</category>

<body package="PV-DM-Support" selector="initialize">initialize
	
	super initialize.
	self type: 'import'.
	self properties: (PvIdentityDictionary new: 16).
	self relations: PvIdentityDictionary new.
	self beEnabled</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>api</category>

<body package="PV-DM-Support" selector="smeeAddChild:">smeeAddChild: anEvent
	&lt;prototypeFunctionNamed: #add length: 1 args: 'anEvent&lt;PvEvent&gt; ' comment: 'This method is used to add a child event to an event object'&gt;

		^self addChild: anEvent</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="postCopy">postCopy
	
	super postCopy.
	self properties notNil 
		ifTrue: 
			[self properties: self properties copy].
	self relations notNil 
		ifTrue: 
			[self relations: self relations copy]</body>

<body package="PV-DM-Support" selector="removeRelation:">removeRelation: anEventRelation 
	
	anEventRelation childId ifNotNil: 
		[:myChildId | 
		self relations 
			removeKey: myChildId
			ifAbsent: []]</body>

<body package="PV-DM-Support" selector="postInsertUpdateIn:">postInsertUpdateIn: aPvModel 
	
	self eventType: 
		(aPvModel eventManager eventTypes 
			detect: [:value | value id == self eventTypeId]
			ifNone: [nil])</body>

<body package="PV-DM-Support" selector="postDomainCopy">postDomainCopy
	
	super postDomainCopy.
	self properties ifNotNil: 
		[:original | 
		self properties: (original copyEmpty: original size).
		original keysAndValuesDo: [:key :value | self properties at: key put: value copy]].
	self relations ifNotNil: 
		[:original | 
		self relations: (original copyEmpty: original size).
		original keysAndValuesDo: [:key :value | self relations at: key put: value copy]]</body>

<body package="PV-DM-Support" selector="addRelation:">addRelation: anEventRelation 
	
	anEventRelation childId ifNotNil: 
		[:myChildId | self relations at: myChildId put: anEventRelation]</body>

<body package="PV-DM-Support" selector="addChild:">addChild: anEvent 
	
	self addRelation: 
		(PvEventRelation 
			parent: self
			child: anEvent)</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="relationsDo:">relationsDo: aBlock 
	
	self relations keysAndValuesDo: [:childId :relation | aBlock value: relation]</body>

<body package="PV-DM-Support" selector="relations">relations
	^relations</body>

<body package="PV-DM-Support" selector="relations:">relations: anObject 
	
	relations := anObject.
	relations whileMutableDo: [relations owner: self]</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="prepareForCommitUsing:">prepareForCommitUsing: anNgModelInterface 
	
	super prepareForCommitUsing: anNgModelInterface.
	self 
		smeePropertyAt: self class nameProperty
		put: self name</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>immutable</category>

<body package="PV-DM-Support" selector="setChildrenImmutable">setChildrenImmutable

	self properties beImmutable.
	self relations beImmutable.</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>relationFrom:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>hasChildren</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>children:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>children</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>childrenDo:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvEvent class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventHistory' put: self historyTableName asString.
	namedReplacements at: 'elementHistory' put: PvElement historyTableName asString.
	namedReplacements at: 'subelementHistory' put: 
		PvSubelement historyTableName asString.
	namedReplacements at: 'columnList' put: 
		(self allHistoricalColumnsForSelectWithPrefix: 'ev.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addToNowDateConditionTo: namedReplacements
			using: parametersDictionary;
		addCollectorClauseNamed: 'eCollectorClause'
			to: namedReplacements
			prefix: 'e'
			using: parametersDictionary;
		addCollectorClauseNamed: 'edCollectorClause'
			to: namedReplacements
			prefix: 'e1'
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString
	
	^'
Select /*+ PUSH_SUBQ ORDERED USE_NL(se ev) INDEX(ev ID_EVDH_4_2) */
       %columnList 
  From ( Select /*+ ORDERED NO_MERGE PUSH_SUBQ USE_NL(e s) */
                s.Idx_Ind
           From %elementHistory e,
                %subelementHistory s
          Where %eCollectorClause
             s.Idx_Host = e.Idx_Ind
            And e.Dte_Date %toNowDateCondition
            And e.Dte_Date = ( Select Max(e1.Dte_Date)
                                 From %elementHistory e1
                                Where e1.Idx_Ind = e.Idx_Ind
                                  And %edCollectorClause
                                  e1.Dte_Date %toNowDateCondition )
            And s.Dte_Date %toNowDateCondition
            And s.Dte_Date = ( Select Max(s1.Dte_Date)
                                 From %subelementHistory s1
                                Where s1.Idx_Ind = s.Idx_Ind
                                  And s1.Dte_Date %toNowDateCondition )
            And e.Str_Action In %actionList
            And s.Str_Action In %actionList ) se,
       %eventHistory ev
 Where ev.Idx_Resource = se.Idx_Ind
   And ev.Dte_Date %resyncDateCondition
   And ev.Dte_Date = ( Select Max(ev1.Dte_Date)
                         From %eventHistory ev1
                        Where ev1.Idx_Ind = ev.Idx_Ind
                          And ev1.Idx_Resource = ev.Idx_Resource
                          And ev1.Dte_Date %resyncDateCondition )
   And ev.Str_Action In %actionList;
'</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent class</class-id> <category>properties</category>

<body package="PV-DM-Support" selector="nameProperty">nameProperty

	^'Name'</body>
</methods>


<methods>
<class-id>PROVISO.PvEventRelation</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="postInsertUpdateIn:">postInsertUpdateIn: aPvModel 
	
	self child: 
		(aPvModel eventManager 
			itemWithId: self childId
			ifAbsent: [nil]).
	self parent: 
		(aPvModel eventManager 
			itemWithId: self parentId
			ifAbsent: [nil]).</body>
</methods>

<methods>
<class-id>PROVISO.PvEventRelation</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="parent:">parent: anObject 
	
	parent := anObject.
	anObject ifNotNil: [:myParent | parentId := myParent id]</body>

<body package="PV-DM-Support" selector="parent">parent
	^parent</body>

<body package="PV-DM-Support" selector="child:">child: anObject
	child := anObject.
	anObject ifNotNil: [:myChild | childId := myChild id].</body>

<body package="PV-DM-Support" selector="child">child
	^child</body>
</methods>


<methods>
<class-id>PROVISO.PvEventRelation class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString

	^'
Select /*+ ORDERED PUSH_SUBQ USE_NL(ev1 eed) */
       %columnList
  From (Select /*+ NO_MERGE PUSH_SUBQ ORDERED USE_NL(se ev) INDEX(ev ID_EVDH_4_2) */
               ev.Idx_Ind
          From (Select /*+ ORDERED NO_MERGE PUSH_SUBQ USE_NL(e s) */
                        s.Idx_Ind
                   From %elementHistory e,
                        %subelementHistory s
                  Where %eCollectorClause
                    s.Idx_Host = e.Idx_Ind
                    And e.Dte_Date %toNowDateCondition
                    And e.Dte_Date = ( Select Max(Dte_Date)
                                         From %elementHistory e1
                                        Where e1.Idx_Ind = e.Idx_Ind
                                          And %edCollectorClause
                                          e1.Dte_Date %toNowDateCondition )
                    And s.Dte_Date %toNowDateCondition
                    And s.Dte_Date = ( Select Max(Dte_Date)
                                         From %subelementHistory s1
                                        Where s1.Idx_Ind = s.Idx_Ind
                                          And s1.Dte_Date %toNowDateCondition )
                    And e.Str_Action In %actionList
                    And s.Str_Action In %actionList ) se,
               %eventHistory ev
         Where ev.Idx_Resource = se.Idx_Ind
           And ev.Dte_Date  %toNowDateCondition
           And ev.Dte_Date = (Select Max(ev1.Dte_Date)
                                From %eventHistory ev1
                               Where ev1.Idx_Ind = ev.Idx_Ind
                                 And ev1.Idx_Resource = ev.Idx_Resource
                                 And ev1.Dte_Date %toNowDateCondition )
           And ev.Str_Action In %actionList) ev1,
       %eventRelationHistory eed
 Where eed.Idx_Parent_Event = ev1.Idx_Ind
   And eed.Dte_Date %resyncDateCondition
   And eed.Dte_Date = ( Select Max(eed1.Dte_Date)
                         From %eventRelationHistory eed1
                         Where eed1.Idx_Parent_Event = eed.Idx_Parent_Event
                           And eed1.Idx_Child_Event = eed.Idx_Child_Event
                           And eed1.Dte_Date %resyncDateCondition )
'</body>

<body package="PV-DM-Support" selector="isHistorical">isHistorical

	^ true</body>

<body package="PV-DM-Support" selector="historyTableName">historyTableName

	^'event_event_desc_hist'</body>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventRelationHistory' put: self historyTableName asString.
	namedReplacements at: 'eventHistory' put: PvEvent historyTableName asString.
	namedReplacements at: 'elementHistory' put: PvElement historyTableName asString.
	namedReplacements at: 'subelementHistory' put: 
		PvSubelement historyTableName asString.
	namedReplacements at: 'columnList' put: 
		(self allHistoricalColumnsForSelectWithPrefix: 'eed.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addToNowDateConditionTo: namedReplacements
			using: parametersDictionary;
		addCollectorClauseNamed: 'eCollectorClause'
			to: namedReplacements
			prefix: 'e'
			using: parametersDictionary;
		addCollectorClauseNamed: 'edCollectorClause'
			to: namedReplacements
			prefix: 'e1'
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulaVisitor</class-id> <category>visitor-callbacks</category>

<body package="PV-DM-Support" selector="acceptFormula:">acceptFormula: aPvFormula 
	
	self pushFormula: aPvFormula.
	[(aPvFormula isOperatorFormulaOrProperty and: [aPvFormula formulaClass isNil]) 
		ifTrue: 
			[PvFormulaCompileNotification 
				signalWith: aPvFormula
				text: 'Missing formula prototype -- probably syntax error'].
	aPvFormula isSpecificToGenericConversion 
		ifTrue: 
			[(self pvModel formulaWithId: aPvFormula genericId) 
				ifNotNil: [:genericFormula | genericFormula addSpecificFormula: aPvFormula]].
	super acceptFormula: aPvFormula] 
		ensure: [self popFormula]</body>
</methods>


<methods>
<class-id>PROVISO.PvInputBuildCommand</class-id> <category>printing</category>

<body package="PV-DM-Support" selector="printOn:">printOn: aStream

	aStream
		nextPutAll: self class name;
		nextPutAll: ' (';
		nextPutAll: self resyncAction asString;
		nextPutAll: ': ';
		nextPutAll: 'operatorTimeSeriesMsid: ';
		print: self operatorTimeSeriesMsid;
		nextPutAll: ' operatorTimeSeriesLabel: ';
		print: self operatorTimeSeriesLabel;
		nextPutAll: ' inputTimeSeriesMsid: ';
		print: self inputTimeSeriesMsid;
		nextPutAll: ' currentResourceId: ';
		print: self currentResourceId;
		nextPutAll: ' sequenceNumber: ';
		print: self sequenceNumber;
		nextPutAll: ' ts: ';
		nextPutAll: self timestamp pvOpportunisticPrintString;
		nextPutAll: ' version: ';
		nextPutAll: self versionDate pvOpportunisticPrintString</body>
</methods>

<methods>
<class-id>PROVISO.PvInputBuildCommand</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="isSameAs:">isSameAs: anotherCommand 
	
	^(super isSameAs: anotherCommand) and: 
		[self operatorTimeSeriesMsid = anotherCommand operatorTimeSeriesMsid and: 
			[self inputTimeSeriesMsid = anotherCommand inputTimeSeriesMsid and: 
				[self operatorTimeSeriesLabel = anotherCommand operatorTimeSeriesLabel and: 
					[self sequenceNumber = anotherCommand sequenceNumber and: 
						[self currentResourceId = anotherCommand currentResourceId]]]]]</body>
</methods>


<methods>
<class-id>PROVISO.PvTimeSeriesBuildCommand</class-id> <category>printing</category>

<body package="PV-DM-Support" selector="printOn:">printOn: aStream

	aStream
		nextPutAll: self class name;
		nextPutAll: ' (';
		nextPutAll: self resyncAction asString;
		nextPutAll: ': ';
		nextPutAll: 'metricId: ';
		print: self metricId;
		nextPutAll: ' resourceId: ';
		print: self resourceId;
		nextPutAll: ' msid: ';
		print: self msid;
		nextPutAll: ' streamLabelId: ';
		print: self streamLabelId;
		nextPutAll: ' ts: ';
		nextPutAll: self timestamp pvOpportunisticPrintString;
		nextPutAll: ' version: ';
		nextPutAll: self versionDate pvOpportunisticPrintString;
		nextPut: $)</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendarIntervalInterface</class-id> <category>visitor-callbacks</category>

<body package="PV-DM-Support" selector="acceptCalendarSegmentWeekendInterval:">acceptCalendarSegmentWeekendInterval: aSegment
	| base dayStart offset |
	base := self timestamp weekStartSeconds.
	self addSegmentBoundaryFrom: base to: self timestamp weekStopSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	aSegment weekendIndices do: [:ix | |dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").
		self 
			addIntervalFrom: (dayStart + aSegment fromTimeSeconds)
			to: (dayStart + aSegment toTimeSeconds)
	]</body>

<body package="PV-DM-Support" selector="acceptCalendarSegmentWeekdayInterval:">acceptCalendarSegmentWeekdayInterval: aSegment

	| base dayStart offset |
	base := self timestamp weekStartSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	self addSegmentBoundaryFrom: base to: self timestamp weekStopSeconds.
	aSegment weekdayIndices do: [:ix | |dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").
		self 
			addIntervalFrom: (dayStart + aSegment fromTimeSeconds)
			to: (dayStart + aSegment toTimeSeconds)
	]</body>

<body package="PV-DM-Support" selector="acceptCalendarSegmentEnumeratedWeekInterval:">acceptCalendarSegmentEnumeratedWeekInterval: aSegment 
	
	| base offset |
	base := self timestamp weekStartSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	self 
		addSegmentBoundaryFrom: base
		to: self timestamp weekStopSeconds.
	aSegment weekEnumerationIndices do: [:ix | |dayStart dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").
		self 
			addIntervalFrom: dayStart + aSegment fromTimeSeconds
			to: dayStart + aSegment toTimeSeconds]</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarIntervalInterface</class-id> <category>api</category>

<body package="PV-DM-Support" selector="intervalForTimestamp:">intervalForTimestamp: aSeconds 
	" It is possible that end of an implicitly built period and the start of explicitly ('in') period overlap. This should really be fixed
	in the build code to prevent this prom happening. In the meantime first search for explicitly built interval, then for an 
	implicit one "
	| result |
	((result := self lastInterval) notNil and: [result includes: aSeconds]) 
		ifTrue: [^result].
	^(self extendHorizonToInclude: aSeconds) ifNotNil: 
		[result := 
			self intervals 
				detect: [:each | (each includes: aSeconds) and: [each inSegment]]
				ifNone: 
					[self intervals 
						detect: [:each | each includes: aSeconds]
						ifNone: [^nil]].
		self lastInterval: result.
		result]</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulaLinker</class-id> <category>api</category>

<body package="PV-DM-Support" selector="link">link
	self class allSmeeFormulasIn: self pvModel do: [:each | each resetFormulaConnections].
	self pvModel formulaManager itemsDo: [:formula | formula resetSpecificFormulas].
	self visit: self pvModel formulaManager</body>
</methods>



<methods>
<class-id>PROVISO.PvDomainObjectManager</class-id> <category>sql statements</category>

<body package="PV-DM-Managers" selector="sqlStatementFor:instanceClass:">sqlStatementFor: sql instanceClass: aClass 
	^self dbSession sqlStatement: sql forClass: aClass</body>
</methods>

<methods>
<class-id>PROVISO.PvDomainObjectManager</class-id> <category>resync support</category>

<body package="PV-DM-Managers" selector="resyncUpdate:from:">resyncUpdate: realObject from: anObject 
	
	self 
		onUpdateItem: realObject
		from: anObject.
	(realObject name ~= anObject name and: [self storesByName]) 
		ifTrue: 
			[self protect: 
				[itemsByName 
					removeKey: anObject name
					ifAbsent: []].
			realObject resyncUpdateFrom: anObject.
			realObject name ifNotNil: 
				[:name | self protect: [itemsByName at: name put: realObject]]]
		ifFalse: [realObject resyncUpdateFrom: anObject].
	realObject postInsertUpdateIn: self pvModel.
	^realObject</body>
</methods>

<methods>
<class-id>PROVISO.PvDomainObjectManager</class-id> <category>database queries - private</category>

<body package="PV-DM-Managers" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
	
	| params |
	params := 
		self 
			createParameters: collectors
			between: startSeconds
			and: endSeconds.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParameters: params)
		instanceClass: self itemClass) do: [:each | self resyncFrom: each]</body>
</methods>

<methods>
<class-id>PROVISO.PvDomainObjectManager</class-id> <category>private</category>

<body package="PV-DM-Managers" selector="createParameters:between:and:">createParameters: collectors between: startSeconds and: endSeconds 
	
	| params |
	params := 
		Dictionary new
			at: #collectors put: collectors;
			at: #startSeconds put: startSeconds;
			at: #endSeconds put: endSeconds;
			yourself.
	^params</body>
</methods>


<methods>
<class-id>PROVISO.PvEventPropertyManager</class-id> <category>database queries - private</category>

<body package="PV-DM-Managers" selector="loadEventAttrTypesWith:">loadEventAttrTypesWith: params 
	
	self dbSession 
		readObjectsOfClass: PvEventAttrType
		with: (PvEventAttrType selectStatementWithParameters: params)
		into: [:each | eventAttrTypes at: each id put: each]</body>

<body package="PV-DM-Managers" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
 
	| params |
	params := self createParameters: collectors between: startSeconds and: endSeconds.
	self loadEventAttrTypesWith: params.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParameters: params)
		instanceClass: self itemClass) 
			do: [ :each | self resyncFrom: each].</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventPropertyManager</class-id> <selector>loadEventAttrTypes</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvModelResyncAgent</class-id> <category>initialize - release</category>

<body package="PV-DM-Managers" selector="initialize">initialize

	super initialize.
	self removedObjects: (PvDictionary newSizedFor: 1000).
	bufferActions := true.
	lastStartSeconds := lastEndSeconds := 0.
	self resyncActions: OrderedCollection new; testResyncActions: OrderedCollection new.
	self updatedProperties: OrderedCollection new.</body>
</methods>

<methods>
<class-id>PROVISO.PvModelResyncAgent</class-id> <category>resync actions</category>

<body package="PV-DM-Managers" selector="updatedProperty:">updatedProperty: property

	updatedProperties ifNotNil: [updatedProperties add: property]</body>
</methods>


<class>
<name>PvModel</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>objects</indexed-type>
<inst-vars>elementManager subelementManager formulaManager requestManager thresholdManager propertyManager calendarManager eventManager eventPropertyManager dataViewApplicationManager idManager idManagerRU collectorsByChannel resyncAgent groupCount loadStatsCollector debugCounters dataloadManager profilesManager snmpConfigurationManager schemaMap relationManager repository idManagerEvent eventRelationManager </inst-vars>
<class-inst-vars>soleInstance </class-inst-vars>
<imports></imports>
<category>PV-DM-Model</category>
<attributes>
<package>PV-DM-Managers</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>dm adding</category>

<body package="PV-DM-Managers" selector="addEvent:">addEvent: anEvent

	self eventManager addEvent: anEvent</body>
</methods>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="allDomainManagerSelectors">allDomainManagerSelectors

	^#(elementManager 	subelementManager formulaManager requestManager thresholdManager calendarManager propertyManager snmpConfigurationManager relationManager profilesManager eventManager eventPropertyManager eventRelationManager)</body>

<body package="PV-DM-Managers" selector="eventRelationManager:">eventRelationManager: anObject
	eventRelationManager := anObject</body>

<body package="PV-DM-Managers" selector="idManagerEvent">idManagerEvent
	idManagerEvent ifNil: [self initializeIdManagerEvent].
	^idManagerEvent</body>

<body package="PV-DM-Managers" selector="eventRelationManager">eventRelationManager
	^eventRelationManager</body>
</methods>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PV-DM-Managers" selector="initializeInMemory">initializeInMemory

	self dbSession
		doSelect: false;
		doNonSelect: false.
	self initOfflineIdManager.

	formulaManager := PvFormulaManager newInMemoryFor: self.
	elementManager := PvElementManager newInMemoryFor: self.
	subelementManager := PvSubelementManager newInMemoryFor: self.
	eventManager := PvEventManager newInMemoryFor: self.
	eventPropertyManager := PvEventPropertyManager newInMemory.
	eventRelationManager := PvEventRelationManager newInMemoryFor: self.
	requestManager := PvRequestManager newInMemory.
	thresholdManager := PvThresholdManager newInMemory.
	calendarManager := PvCalendarManager newInMemory.
	propertyManager := PvPropertyManager newInMemory.
	relationManager := PvRelationManager new.
	dataloadManager := PvDataloadManager newInMemory.
	profilesManager := PvProfilesManager newInMemory.
	snmpConfigurationManager := PvSnmpConfigurationManager newInMemory.

	self makeAllDomainManagersReferToMe.

	collectorsByChannel := Dictionary new.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self).</body>

<body package="PV-DM-Managers" selector="initializeIdManagerEvent">initializeIdManagerEvent
	
	idManagerEvent := 
		PvIdManager new
			setBlockSize: 100;
			makeEvent;
			yourself</body>

<body package="PV-DM-Managers" selector="initialize">initialize
	
	self initOfflineIdManager.
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvElementManager new.
	subelementManager := PvSubelementManager new.
	eventManager := PvEventManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvPropertyManager new.
	eventPropertyManager := PvEventPropertyManager new.
	eventRelationManager := PvEventRelationManager new.
	relationManager := PvRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	repository := nil.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self).
	self initCollectorsByChannel.
	self loadStatsCollector: false</body>

<body package="PV-DM-Managers" selector="initIdManager">initIdManager
	
	idManager := 
		PvIdManager new
			setBlockSize: 100;
			yourself.
	idManagerRU := 
		PvIdManager new
			setBlockSize: 100;
			makeRU;
			yourself.</body>
</methods>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>dm loading/resyncing</category>

<body package="PV-DM-Managers" selector="allManagerSelectors">allManagerSelectors

	^#(elementManager subelementManager formulaManager propertyManager calendarManager thresholdManager requestManager snmpConfigurationManager eventManager eventPropertyManager eventRelationManager).</body>
</methods>


<methods>
<class-id>PROVISO.PvThresholdManager</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="doesExistThresholdsForFormulaId:">doesExistThresholdsForFormulaId: formulaId

	^(self sqlStatementFor: (PvThresholdDefinition selectStatementForFormulaId: formulaId)) contents notEmpty</body>
</methods>


<class>
<name>PvEventRelationManager</name>
<environment>PROVISO</environment>
<super>PROVISO.PvDomainObjectManager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Managers</category>
<attributes>
<package>PV-DM-Managers</package>
</attributes>
</class>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvEventRelationManager</class-id> <category>testing</category>

<body package="PV-DM-Managers" selector="storesByName">storesByName

	^ false</body>
</methods>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvEventRelationManager</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="itemNamed:ifAbsent:">itemNamed: aString ifAbsent: absentBlock

	^PvException generic raiseErrorString: 'Relations do not have names'</body>

<body package="PV-DM-Managers" selector="itemWithId:ifAbsent:">itemWithId: aNumber ifAbsent: absentBlock

	^PvException generic raiseErrorString: 'You cannot retrieve relations by id'</body>

<body package="PV-DM-Managers" selector="itemClass">itemClass

	^PvEventRelation</body>
</methods>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvEventRelationManager</class-id> <category>adding/removing</category>

<body package="PV-DM-Managers" selector="addItem:">addItem: anEventRelation 
	
	(anEventRelation parent isNil or: [anEventRelation child isNil]) 
		ifTrue: [^self].
	anEventRelation parent addRelation: anEventRelation</body>

<body package="PV-DM-Managers" selector="removeItem:">removeItem: anEventRelation

	anEventRelation parent ifNotNil: [:myParent | myParent removeRelation: anEventRelation]</body>
</methods>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvEventRelationManager</class-id> <category>resync support</category>

<body package="PV-DM-Managers" selector="resyncInsertFrom:">resyncInsertFrom: aRelation

	self resyncUpdateFrom: aRelation</body>

<body package="PV-DM-Managers" selector="resyncUpdateFrom:">resyncUpdateFrom: aRelation 
	
	aRelation postInsertUpdateIn: self pvModel.
	self addItem: aRelation</body>

<body package="PV-DM-Managers" selector="resyncDeleteFrom:">resyncDeleteFrom: aRelation

	self removeItem: aRelation</body>
</methods>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvEventRelationManager</class-id> <category>visiting</category>

<body package="PV-DM-Managers" selector="acceptVisit:">acceptVisit: aVisitor

	"do nothing. Relation stored in Events"</body>
</methods>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvEventRelationManager</class-id> <category>initializing</category>

<body package="PV-DM-Managers" selector="newDictionaryForExpectedItemsCount">newDictionaryForExpectedItemsCount
	"needed for itemsByName and itemsById. Not used here"
	^nil</body>

<body package="PV-DM-Managers" selector="initializeInMemoryFor:">initializeInMemoryFor: aModel

	super initializeInMemory.
	self pvModel: aModel.</body>
</methods>


<class>
<name>PvEventManager</name>
<environment>PROVISO</environment>
<super>PROVISO.PvDomainObjectManager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>eventTypes </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Managers</category>
<attributes>
<package>PV-DM-Managers</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvEventManager</class-id> <category>resync support</category>

<body package="PV-DM-Managers" selector="relinkNameFor:">relinkNameFor: anEvent 
	
	anEvent properties do: 
		[:eachProperty | 
		(self pvModel 
			eventAttrTypeWithId: eachProperty attributeId
			ifAbsent: [nil]) ifNotNil: 
				[:type | eachProperty name ifNil: [eachProperty name: type name]]].
	anEvent name ifNil: 
		[anEvent name: 
			(anEvent 
				propertyAt: PvEvent nameProperty
				ifAbsent: [])].
	^anEvent name ifNotNil: [:name | itemsByName at: name put: anEvent]</body>
</methods>

<methods>
<class-id>PROVISO.PvEventManager</class-id> <category>initializing</category>

<body package="PV-DM-Managers" selector="initialize">initialize
	
	super initialize.
	eventTypes := Dictionary new.</body>
</methods>

<methods>
<class-id>PROVISO.PvEventManager</class-id> <category>database queries</category>

<body package="PV-DM-Managers" selector="loadEventTypesWith:">loadEventTypesWith: params 
	
	self dbSession 
		readObjectsOfClass: PvEventType
		with: (PvEventType selectStatementWithParameters: params)
		into: [:each | eventTypes at: each name put: each]</body>

<body package="PV-DM-Managers" selector="dbResync:between:and:">dbResync: collectors between: startSeconds and: endSeconds 
	
	| params |
	params := 
		self 
			createParameters: collectors
			between: startSeconds
			and: endSeconds.
	self loadEventTypesWith: params.
	super 
		dbResync: collectors
		between: startSeconds
		and: endSeconds.</body>

<body package="PV-DM-Managers" selector="dbResyncGlobalBetween:and:">dbResyncGlobalBetween: startSeconds and: endSeconds 
	
	| params |
	params := 
		self 
			createParameters: #()
			between: startSeconds
			and: endSeconds.
	self loadEventTypesWith: params</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventManager</class-id> <selector>relateParent:to:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventManager</class-id> <selector>loadEventRelations</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventManager</class-id> <selector>loadEventTypes</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventManager</class-id> <selector>eventRelations</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvGroupableDomainObjectManager</class-id> <category>resync support</category>

<body package="PV-DM-Managers" selector="resyncUpdateGroupItemRelationshipBetween:and:">resyncUpdateGroupItemRelationshipBetween: parentKey and: childKey 
	
	| parent child |
	parent := self 
		groupWithId: parentKey
		ifAbsent: [^self].
	child := self 
		itemWithId: childKey
		ifAbsent: [^self].

	(child hasParents and: [child parents includes: parent])
		ifFalse: [
			self onUpdateRelationshipOfChildItem: child toParent: parent.
			parent addChild: child.
			child addParent: parent].</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulaManager</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="formulasWithGenericId:do:">formulasWithGenericId: aGenericId do: aBlock 
	
	self itemsDo: 
		[:formula | 
		(formula isSpecificToGenericConversion and: [formula genericId = aGenericId]) 
			ifTrue: [aBlock value: formula]]</body>
</methods>



<class>
<name>TupleSubscription</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name firstUnseen firstNeeded streamFactory containerFactory filters sourceNode destinationNode </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-Tuple Storage Engine</category>
<attributes>
<package>PV-Tuple Storage Engine</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>private</category>

<body package="PV-Tuple Storage Engine" selector="noCheckFirstUnseen:">noCheckFirstUnseen: aPosition

	self firstUnseen = aPosition
		ifTrue: [^self].

	self repository ifNotNil:
		[ :rep |
		rep at: (self name asString, ':firstUnseen') put: aPosition asString].
	self basicFirstUnseen: aPosition</body>

<body package="PV-Tuple Storage Engine" selector="critical:">critical: aBlock

	^self sourceNode critical: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>notification</category>

<body package="PV-Tuple Storage Engine" selector="acceptTuples">acceptTuples

	| ts |
	self critical:
		["Before sending.. attempt to set both firstNeeded &amp; firstUnseen to make sure they are set to valid positions"
		self setFirstNeeded: self firstNeeded firstUnseen: self firstUnseen.

		self sourceStream enumerateStartingAt: self firstUnseen do:
			[ :aTupleContainer :aPosition |
			ts := aTupleContainer timestamp.
			self filters do: [ :filter | filter resyncTo: ts].
			(self  
				acceptTuples: (self filterTuples: aTupleContainer) 
				from: self sourceStream 
				position: aPosition) 
					ifTrue: [self setFirstNeeded: self firstNeeded firstUnseen: (self sourceStream nextPositionAfter: aPosition)]
					ifFalse: [^self]]].</body>
</methods>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>accessing</category>

<body package="PV-Tuple Storage Engine" selector="noCheckFirstNeeded:">noCheckFirstNeeded: aPosition

	self firstNeeded = aPosition
		ifTrue: [^self].

	self repository ifNotNil:
		[ :rep |
		rep at: (self name asString, ':firstNeeded') put: aPosition asString].
	self basicFirstNeeded: aPosition.
	(self sourceStream containerAt: aPosition) ifNotNil:
		[ :container |
		self filters do: [ :filter | filter advancePast: container timestamp]].</body>

<body package="PV-Tuple Storage Engine" selector="firstUnseen:">firstUnseen: aPosition

	self setFirstNeeded: self firstNeeded firstUnseen: aPosition.</body>

<body package="PV-Tuple Storage Engine" selector="firstNeeded:">firstNeeded: aPosition

	self setFirstNeeded: aPosition firstUnseen: self firstUnseen.
	self sourceNode scheduleLangoliering.</body>

<body package="PV-Tuple Storage Engine" selector="setFirstNeeded:firstUnseen:">setFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen

	self critical:
		[| proposedFirstNeeded proposedFirstUnseen |
		proposedFirstNeeded := aFirstNeeded.
		proposedFirstUnseen := aFirstUnseen.

		"If outside the valid range then make it the first valid position"
		(self isValidPosition: proposedFirstNeeded)
			ifFalse: 
				[| firstPos |
				firstPos := self sourceStream firstPosition.
				self 
					logAttemptedToSetFirstNeededToInvalidPos: proposedFirstNeeded 
					insteadSettingTo: firstPos 
					whenSettingFirstNeeded: aFirstNeeded 
					firstUnseen: aFirstUnseen.
				proposedFirstNeeded := firstPos].

		"If outside the valid range then make proposedFistUnseen = proposedFirstNeeded"
		(self isValidPosition: proposedFirstUnseen)
			ifFalse: 
				[self 
					logAttemptedToSetFirstUnseenToInvalidPos: proposedFirstUnseen 
					insteadSettingTo: proposedFirstNeeded 
					whenSettingFirstNeeded: aFirstNeeded 
					firstUnseen: aFirstUnseen.
				proposedFirstUnseen := proposedFirstNeeded].

		"If proposedFistUnseen &lt; proposedFirstNeeded then make proposedFistUnseen = proposedFirstNeeded
			because firstUnseen should not be less than firstNeeded"
		(self sourceStream isPosition: proposedFirstUnseen lessThan: proposedFirstNeeded)
			ifTrue: 
				[self 
					logFirstUnseenShouldAlwaysBeGreatherThanFirstNeeded: proposedFirstNeeded 
					whenSettingFirstNeeded: aFirstNeeded 
					firstUnseen: aFirstUnseen.
				proposedFirstUnseen := proposedFirstNeeded].
		self noCheckFirstNeeded: proposedFirstNeeded.
		self noCheckFirstUnseen: proposedFirstUnseen].</body>
</methods>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>initialize-release</category>

<body package="PV-Tuple Storage Engine" selector="initialize">initialize
	"Initialize a newly created instance. This method must answer the receiver."

	filters := OrderedCollection new add: (WhiteListTupleFilter for: self); yourself.
	streamFactory := [WriteStream on: Array new].
	containerFactory := [ :strm | TupleArray withAll: strm contents].</body>
</methods>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>logging</category>

<body package="PV-Tuple Storage Engine" selector="descriptionOfChangesToFirstNeeded:firstUnseen:">descriptionOfChangesToFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen 

	| changingStream |
	changingStream := String new writeStream.
	self firstNeeded = aFirstNeeded 
		ifFalse: 
			[changingStream nextPutAll: 
				' when changing firstNeeded from: ' , self firstNeeded asString , ' to: ' , 
					aFirstNeeded asString].
	self firstUnseen = aFirstUnseen 
		ifFalse: 
			[changingStream isEmpty 
				ifTrue: [changingStream nextPutAll: ' when ']
				ifFalse: [changingStream nextPutAll: ' and '].
			changingStream nextPutAll: 
				'changing firstUnseen from: ' , self firstUnseen asString , ' to: ' , 
					aFirstUnseen asString].
	^changingStream contents</body>

<body package="PV-Tuple Storage Engine" selector="logFirstUnseenShouldAlwaysBeGreatherThanFirstNeeded:whenSettingFirstNeeded:firstUnseen:">logFirstUnseenShouldAlwaysBeGreatherThanFirstNeeded: proposedFirstNeeded whenSettingFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen

	&lt;comment: 'Attempted to set firstNeeded to a value greater than firstUnseen.  firstUnseen should always be greater than or equal to firstNeeded.  ' 
	probableCause: 'A CME is not behaving correctly' 
	suggestedAction: 'Contact your Proviso system administrator'&gt;

	self system 
		logWarning: #INVALID_POSITION
		messageId: #DC11012
		text: '[' , self sourceNodeName asString, '] -&gt; [', self name asString , '] Adjusting firstUnseen equal to firstNeeded ', proposedFirstNeeded asString , ' because firstUnseen should always be greater than or equal to firstNeeded.  Valid positions are ', self sourceStream validPositionsString , '. - ', (self descriptionOfChangesToFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen)</body>

<body package="PV-Tuple Storage Engine" selector="logAttemptedToSetFirstNeededToInvalidPos:insteadSettingTo:whenSettingFirstNeeded:firstUnseen:">logAttemptedToSetFirstNeededToInvalidPos: invalidPosition
	insteadSettingTo: validPosition
	whenSettingFirstNeeded: aFirstNeeded
	firstUnseen: aFirstUnseen
	&lt;comment: 'The first needed pointer must be set to a position in the source stream that is between the first and last positions that have values. This error is an indication that a CME may not be behaving properly.' 
	probableCause: 'A CME is not behaving correctly' 
	suggestedAction: 'Contact your Proviso system administrator'&gt;
	
	self system 
		logWarning: #INVALID_POSITION
		messageId: #DC11010
		text: 
			'[' , self sourceNodeName asString, '] -&gt; [', self name asString , '] Attempt to set the firstNeeded to an invalid position ' , invalidPosition asString , 
				'.  Valid positions are ',self sourceStream validPositionsString , '.  Instead setting it to ' , validPosition asString, ' - ', (self descriptionOfChangesToFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen)</body>

<body package="PV-Tuple Storage Engine" selector="logAttemptedToSetFirstUnseenToInvalidPos:insteadSettingTo:whenSettingFirstNeeded:firstUnseen:">logAttemptedToSetFirstUnseenToInvalidPos: invalidPosition insteadSettingTo: validPosition whenSettingFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen

	&lt;comment: 'The first unseen pointer must be set to a position in the source stream that is between the first and last positions that have values. This error is an indication that a CME may not be behaving properly.' 
	probableCause: 'A CME is not behaving correctly' 
	suggestedAction: 'Contact your Proviso system administrator'&gt;
	
	self system 
		logWarning: #INVALID_POSITION
		messageId: #DC11014
		text: 
			'[' , self sourceNodeName asString, '] -&gt; [', self name asString , '] Attempt to set the firstUnseen to an invalid position ' , invalidPosition asString , 
				'.  Valid positions are ',self sourceStream validPositionsString , '.  Instead setting it to ' , validPosition asString, ' - ', (self descriptionOfChangesToFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen)</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logFatalSettingFirstUnseenTo:insteadOf:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logFatalSettingFirstNeededTo:insteadOf:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logCannotAdjustFirstNeededBackward:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logInvalidFirstNeededSetting:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logCannotAdjustFirstNeededBeyondFirstUnseen:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logCannotAdjustFirstUnseenBeforeFirstNeeded:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logInvalidFirstUnseenSetting:</selector>
</remove-selector>

<class>
<name>TupleStorageNode</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>owner name currentDataTime client inputs outputs dataStream repository fileInterface subscriptionAgents </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-Tuple Storage Engine</category>
<attributes>
<package>PV-Tuple Storage Engine</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.TupleStorageNode</class-id> <category>private</category>

<body package="PV-Tuple Storage Engine" selector="critical:">critical: aBlock

	^self dataStream critical: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorageNode</class-id> <category>initialize-release</category>

<body package="PV-Tuple Storage Engine" selector="initialize">initialize

	outputs := Dictionary new.
	inputs := Dictionary new.
	dataStream := 
		TupleContainerStream new
			owner: self;
			yourself.
	currentDataTime := nil.
	subscriptionAgents := OrderedCollection new.</body>
</methods>


<methods>
<class-id>PROVISO.PlanBasedSubscriptionAgent</class-id> <category>accessing</category>

<body package="PV-Tuple Storage Engine" selector="createOutput:at:">createOutput: nodeName at: utcSeconds

	^self owner 
		getOutput: nodeName
		ifAbsent:
			[ | subscription |
			subscription := self owner createOutput: nodeName.
			(self owner dataStream positionForTime: utcSeconds)
				ifNotNil:
					[ :position |
					subscription setFirstNeeded: position firstUnseen: position].
			subscription].</body>
</methods>


<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - unioned</category>

<body package="PV-Tuple Storage Engine" selector="getTuplesForMid:rid:from:to:adjTime:count:dbSession:passing:">getTuplesForMid: mid rid: rid from: startTime to: stopTime adjTime: adjTime count: count dbSession: dbSession passing: recompActions
	"&lt;ReadStream&gt; Get all the tuples from tuples storage and the database for the given mid/rid.  Order by tuple timestamp (startTime may be greater than stopTime to indicate reverse order).  The startTime and endTime can be infinite to formulate a query that gets all tuples. The count is used to optimize the database queries, but does not restrict the number of tuples that can be in the resulting read stream (do not read more than count tuples from the resulting read stream, the results may not be accurate)."

	| labels transitionTime tupleStreams start stop adjustmentStart adjustmentStop dbStart dbStop mergeSort direction needTuplesFromTS |
	start := startTime ifNil: [Infinity negative].
	stop := stopTime ifNil: [Infinity positive].
	direction := self directionFrom: startTime to: stopTime ifIndeterminate: [^#() readStream].

	"Determine the earliest time for which TSE has tuples for the given mid/rid"
	labels := self planAccessor labelsForMetricId: mid subelementId: rid between: startTime and: stopTime.
	transitionTime := self getDbPositionOn: labels.
	transitionTime isNil
		ifTrue: [transitionTime := start].

	"If the latest DB time is before the stop time, we need to talk to the CME(s) as well."
	needTuplesFromTS := transitionTime &lt; stop.

	"Now figure out the time ranges for the DB ajustment and tuple queries"
	needTuplesFromTS
		ifTrue: [
			start &lt;= stop
				ifTrue: [
					adjustmentStart := transitionTime + 1 max: start.
					adjustmentStop := stop.
					dbStart := start.
					dbStop := transitionTime]
				ifFalse: [
					adjustmentStart := start.
					adjustmentStop := transitionTime - 1 max: stop.
					dbStart := transitionTime.
					dbStop := stop]]
		ifFalse: [
			dbStart := start.
			dbStop := stop].

	tupleStreams := OrderedCollection new.

	"1) First, lets go after the adjusted tuples from the database...do this first because we want the adjustments to shadow other results (if there are no tuples in tuple storage, no need to do this)."
	needTuplesFromTS 
		ifTrue: [
			tupleStreams add: (self 
				dbGetAdjustedSparseTuplesForMid: mid 
				rid: rid 
				from: adjustmentStart 
				to: adjustmentStop 
				adjTime: adjTime 
				count: count 
				dbSession: dbSession).
			"For now, we don't need the following because we don't support adjustments to periodic metrics"
			"tupleStreams add:
				(self dbGetAdjustedTuplesForMid: mid rid: rid from: adjustmentStart to: adjustmentStop adjTime: adjTime count: count dbSession: dbSession."].

	"2) Next go after tuples outside the Tuple Storage window in the DB"
	tupleStreams add: (self 
		dbGetSparseTuplesForMid: mid 
		rid: rid 
		from: dbStart
		to: dbStop
		adjTime: adjTime 
		count: count 
		dbSession: dbSession).
	tupleStreams add: (self
		dbGetTuplesForMid: mid
		rid: rid 
		from: dbStart 
		to: dbStop 
		adjTime: adjTime 
		count: count 
		dbSession: dbSession).

	"3) Finally, get the tuples from tuple storage (if there aren't any tuples in tuple storage, skip this)"
	needTuplesFromTS 
		ifTrue: [
			tupleStreams add: (self 
				tsGetTuplesForMid: mid 
				rid: rid 
				from: adjustmentStart 
				to: adjustmentStop
				on: labels
				passing: recompActions)]
		ifFalse: [
			self 
				tsGetTuplesForMid: nil 
				rid: nil 
				from: nil 
				to: nil
				on: labels
				passing: recompActions].

	direction &gt;= 0
		ifTrue: [mergeSort := MergeSortStream forTuplesOnAll: tupleStreams]
		ifFalse: [mergeSort := MergeSortStream forReverseTuplesOnAll: tupleStreams].
	^DeduplicatingStream 
		on: mergeSort
		comparisonBlock: [ :a :b | a timestamp = b timestamp]</body>

<body package="PV-Tuple Storage Engine" selector="getTuplesForMid:rid:from:to:adjTime:count:dbSession:">getTuplesForMid: mid rid: rid from: startTime to: stopTime adjTime: adjTime count: count dbSession: dbSession
	"&lt;ReadStream&gt; Get all the tuples from tuples storage and the database for the given mid/rid.  Order by tuple timestamp (startTime may be greater than stopTime to indicate reverse order).  The startTime and endTime can be infinite to formulate a query that gets all tuples. The count is used to optimize the database queries, but does not restrict the number of tuples that can be in the resulting read stream (do not read more than count tuples from the resulting read stream, the results may not be accurate)."

	^self
		getTuplesForMid: mid
		rid: rid 
		from: startTime 
		to: stopTime 
		adjTime: adjTime 
		count: count 
		dbSession: dbSession 
		passing: #()</body>

<body package="PV-Tuple Storage Engine" selector="getDbPositionForType:on:">getDbPositionForType: tupleType on: labels

	| stream timestamps |
	labels isEmpty
		ifTrue: [^nil].

	stream := (WriteStream on: (String new: 100))
		nextPutAll: 'select 
  max(s.dte_last_load_date) as startOfLastLoadedPeriod
from chnl_table_set_type t, chnl_table_load_status s 
where t.idx_ind = s.IDX_TABLE_SET_TYPE and t.str_name = ';
		nextPutAll: tupleType printString;
		nextPutAll: ' and s.idx_subchnl in (';
		yourself.

	labels
		do: [:each | stream print: each]
		separatedBy: [stream nextPutAll: ', '].

	stream nextPutAll:  ')'.

	timestamps := (self dbSession execute: stream contents) collect: [:each | each first].
	timestamps := timestamps reject: [:each | each isNil].
	^timestamps isEmpty
		ifTrue: [nil]
		ifFalse: [
			timestamps
				inject: timestamps first
				into: [:sum :each | sum max: each]].</body>

<body package="PV-Tuple Storage Engine" selector="getDbPositionOn:">getDbPositionOn: labels

	| sparseTimestamp periodicTimestamp |
	sparseTimestamp := self getDbPositionForType: 'SNRW' on: labels.
	periodicTimestamp := self getDbPositionForType: 'NRAW' on: labels.

	"We add 3599 to the timestamp, since the DB column we're reading is start of period..."
	sparseTimestamp isNil
		ifTrue: [^periodicTimestamp].
	periodicTimestamp isNil
		ifTrue: [^sparseTimestamp].
	^(sparseTimestamp min: periodicTimestamp) + 3599</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - for recomp</category>

<body package="PV-Tuple Storage Engine" selector="getMetricsForMid:rid:between:and:adjTime:passing:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber adjTime: adjTime passing: recompActions
	"&lt;Array&gt; Ask tuple storage for the set of metric records in the given timeframe, with the given mid/rid."
	
	| strm |
	[strm := self
		getTuplesForMid: metricId
		rid: resourceId
		from: (self decodeInfinity: startTsNumber)
		to: (self decodeInfinity: endTsNumber)
		adjTime: (self decodeInfinity: adjTime)
		count: Infinity positive
		dbSession: self dbSession
		passing: recompActions.
	^strm upToEnd]
		ensure: [strm ifNotNil: [strm close]]</body>

<body package="PV-Tuple Storage Engine" selector="getMetricsForMid:rid:between:and:adjTime:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber adjTime: adjTime
	"&lt;Array&gt; Ask tuple storage for the set of metric records in the given timeframe, with the given mid/rid."
	
	^self getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber adjTime: adjTime passing: #()</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - tuple storage</category>

<body package="PV-Tuple Storage Engine" selector="tsGetTuplesForMid:rid:from:to:">tsGetTuplesForMid: mid rid: rid from: startTime to: endTime

	| labels |
	labels := self planAccessor labelsForMetricId: mid subelementId: rid between: startTime and: endTime.
	^self
		tsGetTuplesForMid: mid 
		rid: rid 
		from: startTime 
		to: endTime 
		on: labels 
		passing: #()</body>

<body package="PV-Tuple Storage Engine" selector="handleRemoteQueryForMid:rid:from:to:on:for:passing:">handleRemoteQueryForMid: mid rid: rid from: startTime to: endTime on: label for: agent passing: recompActions

	| cmePair remoteStream |
	cmePair := CMETimeSeries new getApplicationForOperatorLabel: label.
	cmePair value isNil
		ifFalse: [
			| cmeApplication |
			cmeApplication := cmePair value.
			[
				remoteStream := RemoteStreamProxy on: (cmeApplication server streamLabelOperator
					protectedHandleRecomputationRecords: recompActions
					whileGettingTuplesForMid: mid
					rid: rid 
					from: startTime 
					to: endTime).
				remoteStream finalizeAction: #destroy]
			on: Error 
			do: [ :ex | 
				self logRemoteQueryFailed: ex label: label.
				ex pass]].

	^remoteStream</body>

<body package="PV-Tuple Storage Engine" selector="tsGetTuplesForMid:rid:from:to:on:passing:">tsGetTuplesForMid: mid rid: rid from: startTime to: endTime on: labels passing: recompActions

	| agents results |
	(mid isNil and: [recompActions isEmpty])
		ifTrue: [^self].
	agents := labels collect: [ :label | label -&gt; (self lookupNode: label ifAbsent: [nil])].
	agents := agents select: [ :ea | ea value notNil].
	results := OrderedCollection new.
	agents do:
		[ :assn |
		| agent label |
		agent := assn value.
		label := assn key.
		agent isRemote
			ifTrue: [
				| value |
				self logRemoteQuery: assn key agent: agent mid: mid rid: rid from: startTime to: endTime.
				value := self
					handleRemoteQueryForMid: mid
					rid: rid 
					from: startTime 
					to: endTime 
					on: label 
					for: agent 
					passing: recompActions.
				value notNil ifTrue: [results add: value]]
			ifFalse: [results add: (agent getTuplesForMid: mid rid: rid from: startTime to: endTime)]].
	^mid isNil
		ifTrue: [self]
		ifFalse: [
			(self directionFrom: startTime to: endTime) &gt;= 0
				ifTrue: [MergeSortStream forTuplesOnAll: results]
				ifFalse: [MergeSortStream forReverseTuplesOnAll: results]]</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - database</category>

<body package="PV-Tuple Storage Engine" selector="dbGetAdjustedSparseTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetAdjustedSparseTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession

	| adjClause |
	adjTime &gt; 0
		ifTrue: 
			[(adjTime == Infinity positive)
				ifTrue: [adjClause := '']
				ifFalse: [adjClause := 'and t2.dte_adj_date &lt;= :3']]
		ifFalse: 
			["This query is only interested in the sparse metrics...if adjTime &lt;= 0, nothing will be returned from the DB query anyway, so don't bother"
			^#() readStream].
	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: (adjClause isEmpty ifTrue: [3] ifFalse: [4]) do:
		[ :rangeClause :orderClause :vars | | sql |
		vars 
			at: 1 put: mid;
			at: 2 put: rid.
		adjClause isEmpty ifFalse: [vars at: 3 put: adjTime].
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value, idx_event
				from MTRC00_SNRW_000_FULL t1 
				where 
					idx_metric = :1 
					and idx_resource = :2 ',
					rangeClause,
					' and dte_adj_date &lt;&gt; 0
					and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date ', adjClause,') 
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvSparseMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					eventId: ((row at: 5) ifNil: [0]);
					yourself]].
	^#() readStream</body>

<body package="PV-Tuple Storage Engine" selector="dbGetSparseTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetSparseTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession

	| adjClause |
	adjClause := 'and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date'.
	adjTime &gt; 0
		ifTrue: 
			[(adjTime == Infinity positive)
				ifTrue: [adjClause := adjClause, ')']
				ifFalse: [adjClause := adjClause, ' and t2.dte_adj_date &lt;= :3)']]
		ifFalse: 
			[adjClause := 'and dte_adj_date = 0'].

	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: 4 do:
		[ :rangeClause :orderClause :vars | | sql |
		"We do the following because apparently Oracle applies the rownum clause before it sorts the results (ARG!)."
		vars 
			at: 1 put: mid;
			at: 2 put: rid;
			at: 3 put: adjTime.
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value, idx_event
				from MTRC00_SNRW_000_FULL t1 
				where 
					idx_metric = :1
					and idx_resource = :2
					', rangeClause, '
					 and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date)
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvSparseMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					eventId: (row at: 5);
					yourself]].
	^#() readStream</body>

<body package="PV-Tuple Storage Engine" selector="dbGetTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession
	"Note: adjTime is ignored because we don't currently support adjustments to periodic metrics"
	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: 3 do:
		[ :rangeClause :orderClause :vars | | sql |
		vars 
			at: 1 put: mid;
			at: 2 put: rid.
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value
				from MTRC00_NRAW_000_FULL t1 
				where 
					idx_metric = :1 
					and idx_resource = :2
					', rangeClause, '
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					yourself]].
	^#() readStream</body>
</methods>



<methods>
<class-id>PROVISO.PvFormulas.PvCflFormula</class-id> <category>mutating</category>

<body package="PV CML-Framework" selector="recompileWithFormula:">recompileWithFormula: aFormula

	" Do nothing here "</body>
</methods>

<methods>
<class-id>PROVISO.PvFormulas.PvCflFormula</class-id> <category>updating</category>

<body package="PV CML-Framework" selector="onAddTuple:">onAddTuple: aTuple
	"do nothing"</body>

<body package="PV CML-Framework" selector="runCalculationMethod">runCalculationMethod
	
	[| result resultRecord |

	self timeSeries ifNotNil: [:ts | ts shouldFire ifFalse: [^self]].

	xxxPrivateFormulaResult := nil.
	[((result := self calculate) notNil and: [result ~~ self]) 
		ifTrue: 
			[result := 
				self class outputType == self class numberType 
					ifTrue: [result value asNumber]
					ifFalse: [result value asString].
			xxxPrivateFormulaResult := result]] 
				on: Error
				do: [:err | ^self logCalculationError: err].

	xxxPrivateFormulaResult isNil 
		ifFalse: 
			[[resultRecord := self buildResultMetricRecord] 
				on: Error
				do: [:err | ^self logBuildResultMetricRecordError: err].
			self owner isEnabled
				ifTrue: [self owner onAddTuple: resultRecord]]] 
				ensure: [self resetInputState]</body>

<body package="PV CML-Framework" selector="shouldDeduplicateOnAddTuple:">shouldDeduplicateOnAddTuple: aTuple

	^false</body>
</methods>



<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>builder protocol</category>

<body package="PV-ES-Formulas" selector="disconnect">disconnect

	self removeSpecificToGenericDependency.

	self beImplicit; shouldStore: false.
	super disconnect.</body>

<body package="PV-ES-Formulas" selector="removeSpecificToGenericDependency">removeSpecificToGenericDependency
	"I might be the generic.  If any specific ts point to me because i am generic, then remove me from that dependents collection"
	
	self tupleRepository 
		specificTimeseriesFor: self
		do: [:each | each removeDependent: self]</body>
</methods>

<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>shouldFire flag</category>

<body package="PV-ES-Formulas" selector="shouldFire">shouldFire

	^true</body>

<body package="PV-ES-Formulas" selector="shouldFire:">shouldFire: aBool
	"Ignore"</body>
</methods>

<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="dependentComputationsDo:">dependentComputationsDo: aBlock 

	self dependents do:
		[:dependent | 
		((dependent isKindOf: FormulaOperator) or: 
			[(dependent isKindOf: PROVISO.PvFormulas.PvCflFormula) or:
				[dependent isKindOf: TimeSeries]])
					ifTrue: [aBlock value: dependent]]</body>
</methods>


<methods>
<class-id>PROVISO.TimeSeries class</class-id> <category>database support</category>

<body package="PV-ES-Formulas" selector="bindVariableSelectStatementForLabelForMetricId:subelementId:between:and:">bindVariableSelectStatementForLabelForMetricId: metricId 
	subelementId: subelementId
	between: beginTimestamp
	and: endTimestamp
	"self bindVariableSelectStatementForLabelForMetricId: 1234 subelementId: 4567 between: 5000 and: 1000"

	| bindVariableArray dateClause begin end subquery |
	begin := beginTimestamp ifNil: [Infinity negative].
	end := endTimestamp ifNil: [Infinity positive].
	(((begin == Infinity negative) or: [begin == Infinity positive]) and: [begin == end])
		ifTrue: [^nil].
	end &lt; begin ifTrue: [^nil].

	bindVariableArray := Array new: 4.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.
	bindVariableArray at: 3 put: begin.
	bindVariableArray at: 4 put: end.

	subquery := 
		'OR ts.int_version_date = 
			(SELECT MAX(ts2.int_version_date)
				FROM ts_desc ts2
				WHERE 
					ts2.idx_metric = :1 
					AND ts2.idx_resource = :2
					AND ts2.dte_date &lt; :3)'.
	((begin ~~ Infinity negative) and: [end ~~ Infinity positive]) 
		ifTrue:
			[dateClause := 'and (ts.dte_date between :3 and :4 ', subquery, ')']
		ifFalse:
			[((begin == Infinity negative) and: [end == Infinity positive])
				ifTrue:
					[dateClause := ''.
					bindVariableArray := bindVariableArray copyFrom: 1 to: 2]
				ifFalse:
					[(begin == Infinity negative) ifTrue: 
						[dateClause := 'and ts.dte_date &lt;= :3'.
						bindVariableArray at: 3 put: endTimestamp].
					(end == Infinity positive) ifTrue: 
						[dateClause := 'and (ts.dte_date &gt;= :3 ', subquery, ')'].
					bindVariableArray := bindVariableArray allButLast]].

	^('SELECT distinct ts.int_label
		FROM ts_desc ts
		WHERE 
			ts.idx_metric = :1 
			and ts.idx_resource = :2 
			and ts.str_action = ''I''', dateClause)
    				-&gt; bindVariableArray</body>

<body package="PV-ES-Formulas" selector="bindVariableSelectStatementForCurrentLabelForMetricId:subelementId:">bindVariableSelectStatementForCurrentLabelForMetricId: metricId subelementId: subelementId
	"self bindVariableSelectStatementForCurrentLabelForMetricId: 1234 subelementId: 4567"

	| bindVariableArray |

	bindVariableArray := Array new: 2.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.

	^'SELECT distinct ts.int_label
		FROM ts_desc ts
		WHERE 
			ts.idx_metric = :1 
			and ts.idx_resource = :2 
			and ts.str_action = ''I'' 
			and ts.int_version_date = 
				(SELECT MAX(ts2.int_version_date)
					FROM ts_desc ts2
					WHERE 
						ts2.idx_metric = :1 
						AND ts2.idx_resource = :2)'
    				-&gt; bindVariableArray</body>
</methods>


<methods>
<class-id>PROVISO.FormulaSet class</class-id> <category>instance creation</category>

<body package="PV-ES-Formulas" selector="validateFromFile:infoOn:">validateFromFile: aFilename infoOn: aStrm

	| fileSet dbSet deltas model failures insertOrUpdate |
	insertOrUpdate := 
		[ :formulaName | | formula frmlProto newId |
		formula := fileSet formulaNamed: formulaName.
		[formula id: (dbSet formulaNamed: formulaName) id] on: Error do: [ :ex | ].
		frmlProto := formula formulaPrototype.
		newId := 0.
		model formulaManager
			addFormula: formula
			named: formulaName
			withSeparator: $~
			idCallback:
				[[newId := newId + 1.
				(model formulaManager itemWithId: newId) isNil and: [(model formulaManager groupWithId: newId) isNil]] whileFalse.
				newId]
			insertCallback: [ :obj |].
		formula formulaPrototype: frmlProto].

	aStrm cr; nextPutAll: 'Validating Formulas'; cr; flush.

	"turn off dbinsert/update"
	self dbSession doNonSelect: false.
	
	PROVISO.UBA.Environment new do:
		[model := 
			PvModel new 
				initializeForCme; 
				initIdManager;
				yourself.
		"Resync up to 1 day to avoid any issues with local timezone settings"
		model
			resyncDomainManagers: #(formulaManager calendarManager requestManager thresholdManager subelementManager)
			collectors: nil
			between: 0
			and: (self timeFacade now asUTCSeconds + 86400).

	"Catch basic compile errors in the file"
		[fileSet := self loadFromFile: aFilename]
			on: Error
			do: 
				[:ex | 
				aStrm nextPutAll: 'Validation failed while compiling formula file! Problem found:'.
				aStrm cr; nextPutAll: ex description.
				aStrm cr.
				^false].

		dbSet := self formulasForDoc: fileSet documentName inModel: model.
		deltas := fileSet asMutationsOf: dbSet.

		(deltas at: #deletes) do: 
			[ :formulaName | 
			(model formulaNamed: formulaName) ifNotNil: [:formula |
			model requestManager allItems do: [:request |
				| error |
				error := (request formula notNil and: [request formula id = formula id]) 
					or: [request formulaIndex = formula id
						or: [request genericFormula notNil and: [request genericFormula id = formula id]]].
				error
					ifTrue: [
						aStrm nextPutAll: 'Validation failed: formula ', formulaName.
						aStrm nextPutAll: ' referenced by request with id: ', request id printString.
						aStrm cr.
						^false]].

			(model thresholdManager doesExistThresholdsForFormulaId: formula id)
				ifTrue: [
					aStrm nextPutAll: 'Validation failed: formula ', formulaName.
					aStrm nextPutAll: ' referenced by threshold(s)'.
					aStrm cr.
					^false].

			model formulaManager removeItemWithId: formula id ifAbsent: []]].

		(deltas at: #inserts) do: insertOrUpdate.
		(deltas at: #updates) addAll: (deltas at: #unchanged). "update all formulas, even the unchanged ones"
		(deltas at: #updates) do: insertOrUpdate].

	failures := OrderedCollection new.
	"explicitly call linker"
	[PvFormulaLinker linkPvModelAndAssignArgumentIds: model]
		on: PvFormulaCompileNotification
		do: [:ex | 
			failures add: ex.
			ex resume].

	fileSet formulas keysAndValuesDo: 
		[:eachFname :eachPvFormula | | window calName |
		window := eachPvFormula formulaPrototype window.
		window isCalendarBased ifTrue:
			[calName := eachPvFormula formulaPrototype window calendarName.
			model calendarManager
				itemNamed: (LocalizedSchedule calendarNameFrom: calName) 
				ifPresent: 
					[:cal |
					cal isSuitableForCalendarWindow ifFalse:
						[failures add:
							(GeneralError new
								owner: self;
								description: 'Calendar ', calName, ' in formula ', eachFname, ' is not suitable for period definition (hint: check segment''s str_to_time)';
								yourself)]]
				ifAbsent: 
					[failures add:
						(GeneralError new
							owner: self;
							description: 'Calendar referenced by ', calName, ' in formula ', eachFname, ' is not presently defined';
							yourself)]]].

	"turn on insert/update"
	self dbSession doNonSelect: true.

	failures isEmpty
		ifTrue: [aStrm nextPutAll: 'Validation Succeeded, Loading formulas'; cr]
		ifFalse:
			[aStrm nextPutAll: 'Validation Failed! Problems found:'.
			failures do: [:ex | aStrm cr; nextPutAll: ex description].
			aStrm cr].

	^failures isEmpty</body>

<body package="PV-ES-Formulas" selector="installFromFile:infoOn:">installFromFile: aFilename infoOn: aStrm 

	| fileSet dbSet deltas model argMapInsert highWatermark |
	highWatermark := self timeFacade nowAsSeconds.
	(self 
		validateFromFile: aFilename
		infoOn: aStrm) 
			ifFalse: [^nil].
	PROVISO.UBA.Environment new do: 
		[model := 
			PvModel new
				initializeForCme;
				initIdManager;
				yourself.
		"Resync up to 1 day to avoid any issues with local timezone settings"
		model 
			resyncDomainManagers: #(formulaManager calendarManager)
			collectors: nil
			between: 0
			and: self timeFacade now asUTCSeconds + 8640.
		fileSet := self loadFromFile: aFilename.
		fileSet do: [:ea | ea resyncHistoricalDate: Infinity positive].
		dbSet := 
			self 
				formulasForDoc: fileSet documentName
				inModel: model.
		deltas := fileSet asMutationsOf: dbSet.
		"TODO: only store the document if there has been a change in the text of the document...also, need to be able to handle document include statements."
		model formulaManager 
			storeDocument: aFilename
			named: fileSet documentName.
		"The following code needs to be retained and will be utilized in the future, for now, the plumbing is not in place to support it -spair/apikovsky"
		"argMapInsert := (String new: 1024) streamContentsDo: [:stream |
					stream nextPutAll: 'insert into FRML_ARG (idx_ind, str_arg_path, dte_date) values ('; cr.
					(model formulaManager argumentMap associations 
						select: [:eachAssoc | eachAssoc value key &gt;= highWatermark])
							do: [:eachAssoc |
								stream
									print: eachAssoc value value; nextPut: $,; space;
									nextPutAll: eachAssoc key; nextPut: $,; space;
									print: eachAssoc value key]
							separatedBy: [stream  nextPut: $,; cr].
					stream cr; nextPutAll: ')'.
				].
				self dbSession executeNonSelect: argMapInsert."
		aStrm nextPutAll: 'Deleted Formulas:'.
		(deltas at: #deletes) isEmpty 
			ifTrue: [aStrm nextPutAll: ' (none)'].
		aStrm cr.
		(deltas at: #deletes) do: 
			[:formulaName | 
			aStrm
				nextPutAll: '   ';
				nextPutAll: formulaName;
				cr.
			(dbSet formulaNamed: formulaName) dbDelete].
		aStrm nextPutAll: 'Inserted Formulas:'.
		(deltas at: #inserts) isEmpty 
			ifTrue: [aStrm nextPutAll: ' (none)'].
		aStrm cr.
		(deltas at: #inserts) do: 
			[:formulaName | 
			| formula |
			aStrm
				nextPutAll: '   ';
				nextPutAll: formulaName;
				cr.
			formula := fileSet formulaNamed: formulaName.
			model formulaManager 
				dbAddFormula: formula
				named: formulaName
				withSeparator: $~.
			model formulaManager 
				associateFormula: formula
				withDocument: fileSet documentName].
		aStrm nextPutAll: 'Updated Formulas:'.
		(deltas at: #updates) addAll: (deltas at: #unchanged).
		"update all formulas, even the unchanged ones"
		(deltas at: #updates) isEmpty 
			ifTrue: [aStrm nextPutAll: ' (none)'].
		aStrm cr.
		(deltas at: #updates) do: 
			[:formulaName | 
			| formula |
			aStrm
				nextPutAll: '   ';
				nextPutAll: formulaName;
				cr.
			formula := fileSet formulaNamed: formulaName.
			formula id: (dbSet formulaNamed: formulaName) id.
			(dbSet formulaNamed: formulaName) group ifNotNil: [:grp | formula group: grp].
			formula dbUpdate]].

	self installDummyFormulasForCalendarsIn: model infoOn: aStrm</body>
</methods>


<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>smee interface</category>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate 
	&lt;prototypeFunctionNamed: #emitTuple length: 1 args: 'tuple' selector: #emitTuple:
	comment: 'Emits new tuple'&gt;
	
	^self window 
		emitTuple: aTuple
		shouldDeduplicate: shouldDeduplicate
		formulaOperator: self</body>

<body package="PV-ES-Formulas" selector="onAddTuple:">onAddTuple: aTuple

	self window onAddTuple: aTuple formulaOperator: self</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:">shouldDeduplicateOnAddTuple: aTuple

	^self window shouldDeduplicateOnAddTuple: aTuple formulaOperator: self</body>
</methods>

<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>windowing api</category>

<body package="PV-ES-Formulas" selector="evaluate:withTuple:">evaluate: sel withTuple: aTuple 
	|temp|

	self timeSeries ifNotNil: [:ts | ts shouldFire ifFalse: [^nil]].

	^self environment do: 
		[[temp := self 
			invokeSmeeCallback: sel
			withArguments: (Array with: aTuple)
			ifAbsent: [nil]] 
				on: Error
				do: 
					[:err | 
					FormulaCalculationError 
						raiseRequestWith: self formula-&gt;sel 
						errorString: 'Calc error in ', sel, '(), formula ', self formula printString, ' mid: ', self metricId printString ,' rid: ', self resourceId printString, ', error: ', err description.
					(self inputs conform: [:eachInput | eachInput notNil])
						ifTrue: 
							[self 
								logWarnFailedCalculate: self formula printString
								selector: sel
								msg: err description  , ' for mid: ', self metricId printString ,' rid: ', self resourceId printString]
						ifFalse: 
							[| missingArgs |
							missingArgs := OrderedCollection new: self formula arguments size.
							self formula arguments keysAndValuesDo:  
								[:eachIx :eachArg | (self inputs at: eachIx) ifNil: [missingArgs add: eachArg]].
							self 
								logWarnFailedCalculate: self formula printString
								selector: sel
								msg: 'Formula is missing input(s) for arguments: ', missingArgs asArray printString , ' for mid: ', self metricId printString ,' rid: ', self resourceId printString].
					nil]]</body>
</methods>

<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>mutating</category>

<body package="PV-ES-Formulas" selector="recompileWithFormula:">recompileWithFormula: aFormula 
	" Replace the prototype with the new formula and reshape the inputs "
	
	| oldInputs newInputs obsoleteInputs |
	oldInputs := self inputs.
	newInputs := Array new: aFormula arguments size.
	" Get all the inputs that are preserved between in the new version of the formula and put them in proper place at the new inputs array"
	aFormula arguments keysAndValuesDo: 
		[:ix :eachArgument | 
		| oldInput |
		oldInput := 
			oldInputs 
				detect: [:eachInput | eachInput notNil and: [eachInput sequenceNumber = eachArgument id]]
				ifNone: [nil].
		oldInput ifNotNil: [newInputs at: ix put: oldInput]].

	" These inputs should have been deleted in an orderly fashion, so their presence may be an indication of some problem in the logic "
	obsoleteInputs := 
		oldInputs reject: 
			[:eachInput | 
			eachInput isNil 
				or: [aFormula arguments anySatisfy: [:eachArgument | eachInput sequenceNumber = eachArgument id]]].
	obsoleteInputs do: 
		[:eachInput | 
		self system 
			logDebugOne: #DISCONNECT_OBSOLETE_INPUT
			messageId: nil
			text: 
				'Removing input because of formula change. Time series ' , 
					self id printString , ', input: ' , eachInput printString.
		eachInput disconnect].
	self smeePrototype: aFormula.
	self inputs: newInputs.
	self removeSmeePropertiesForObsoleteFormulaInputs</body>

<body package="PV-ES-Formulas" selector="removeSmeePropertiesForObsoleteFormulaInputs">removeSmeePropertiesForObsoleteFormulaInputs
	" If a formula loses some inputs, Smee propeties that make those inputs accessible in Smee
	should also be removed. I.e. formula inputs change from 
		a1, a2, a3
	to 
		a2, a5
	This means we should remove Smee properties a1 and a3 "

	| obsoleteSmeeInputProperties |
	obsoleteSmeeInputProperties := OrderedCollection new.
	self enumerablePropertiesDo: 
		[:eachModifier | 
		((eachModifier value isKindOf: AbstractInput) and: [(self inputs includes: eachModifier value) not])
			ifTrue: [obsoleteSmeeInputProperties add: eachModifier]].
	
	obsoleteSmeeInputProperties do: [:eachModifier |
		self smeeDelete: eachModifier key].</body>
</methods>


<methods>
<class-id>PROVISO.FormulaWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator lastTuple 
		ifNil: 
			[aFormulaOperator timeSeries ifNotNil: 
				[:ts | 
				self 
					doEmitTuple: aTuple
					formulaOperator: aFormulaOperator
					timeSeries: ts]]
		ifNotNil: 
			[:last | 
			aTuple timestamp &lt; last timestamp 
				ifTrue: [nil]
				ifFalse: 
					[((shouldDeduplicate or: [aTuple timestamp = last timestamp]) and: 
						[last value = aTuple value]) 
							ifTrue: [aFormulaOperator deduplicateTuple: aTuple]
							ifFalse: 
								[aFormulaOperator timeSeries ifNotNil: 
									[:ts | 
									self 
										doEmitTuple: aTuple
										formulaOperator: aFormulaOperator
										timeSeries: ts]]]]</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	^false</body>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		aFormulaOperator lastTuple: aTuple.
		ts onAddTuple: aTuple.</body>
</methods>


<methods>
<class-id>PROVISO.LocalizedSchedule</class-id> <category>testing</category>

<body package="PV-ES-Formulas" selector="isGenericFormula">isGenericFormula

	^false</body>
</methods>


<methods>
<class-id>PROVISO.TupleWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator timeSeries ifNotNil: 
		[:ts | 
		self 
			doEmitTuple: aTuple
			formulaOperator: aFormulaOperator
			timeSeries: ts]</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator

	aFormulaOperator lastTuple: aTuple</body>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		ts onBufferTuple: aTuple</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	| last |

	"If we don't have a lastTuple then we should produce a value"
	(last := formulaOperator lastTuple) ifNil: [^false].

	"There should never be a new tuple for an earlier timestamp (moving back in time)"
	aTuple timestamp &lt; last timestamp
		ifTrue: [^true].

	"There should never be 2 tuples for the same timestamp"
	(aTuple timestamp = last timestamp and: [last value = aTuple value])
		ifTrue: [^true].

	"Real deduplication - where previous value is the same as this value"
	(formulaOperator shouldDeduplicate and: [last value = aTuple value])
		ifTrue: [^true].

	^false</body>
</methods>


<methods>
<class-id>PROVISO.CMEWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	^false</body>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator lastTuple 
		ifNil: 
			[aFormulaOperator timeSeries ifNotNil: 
				[:ts | 
				self 
					doEmitTuple: aTuple
					formulaOperator: aFormulaOperator
					timeSeries: ts]]
		ifNotNil: 
			[:last | 
			aTuple timestamp &lt; last timestamp 
				ifTrue: [nil]
				ifFalse: 
					[((shouldDeduplicate or: [aTuple timestamp = last timestamp]) and: 
						[last value = aTuple value]) 
							ifTrue: [aFormulaOperator deduplicateTuple: aTuple]
							ifFalse: 
								[aFormulaOperator timeSeries ifNotNil: 
									[:ts | 
									self 
										doEmitTuple: aTuple
										formulaOperator: aFormulaOperator
										timeSeries: ts]]]]</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator</body>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		aFormulaOperator lastTuple: aTuple.
		ts onAddTuple: aTuple.</body>
</methods>



<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>logging</category>

<body package="PV-CME-Core" selector="logNoRequestsForSpecificFormulaForGenericTimeSeries:">logNoRequestsForSpecificFormulaForGenericTimeSeries: aTimeSeries 
	
	self system
		logWarning: #NO_SPECIFIC_FORMULA_REQUEST
		messageId: #DC10011
		text: 'There is no specific formula request for timeseries: ' , aTimeSeries printString</body>

<body package="PV-CME-Core" selector="logTooManySpecificFormulaRequests:forGenericTimeSeries:">logTooManySpecificFormulaRequests: aCollOfReqs forGenericTimeSeries: aTimeSeries

	self system
		logWarning: #TOO_MANY_SPECIFIC_FORMULA_REQUESTS
		messageId: #DC10012
		text: 'There are too many specific formula requests for ' , aTimeSeries printString , ' ' , aCollOfReqs asArray printString , '.  This is a misconfiguration that can cause loss of data and excessive plan churn'.</body>
</methods>

<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>building buckets</category>

<body package="PV-CME-Core" selector="specificIdAndRequestForGenericTimeSeriesId:do:">specificIdAndRequestForGenericTimeSeriesId: genId do: aBlock

	| specificRequests specificRequest specificId |
	genId formula isGenericFormula ifFalse: [^nil].
	specificRequests := nil.
	genId resource metricRequestsDo: 
		[:req | 
			(genId formula specificFormulas anySatisfy: [:eachFormula | eachFormula isSnmpFormula not and: [eachFormula = req formula]])
				ifTrue: 
					[specificRequests ifNil: [specificRequests := IdentitySet new].
					specificRequests add: req]].
	specificRequests ifNil: 
		["self logNoRequestsForSpecificFormulaForGenericTimeSeries: genId."
		^nil].

	specificRequests size &gt; 1 
		ifTrue: [self logTooManySpecificFormulaRequests: specificRequests forGenericTimeSeries: genId].

	(specificRequest := specificRequests anyOne) currentResource: genId resource.
	specificId := MetricSeriesIdentifier metric: specificRequest formula resource: genId resource.
	aBlock value: specificId value: specificRequest</body>

<body package="PV-CME-Core" selector="buildForRequest:id:explicit:">buildForRequest: aRequest id: aTSid explicit: aBoolean 

	| ts tsgen request explicit returnSpecific specificId genericId |
	(specificId := self getActualIdForRequest: aRequest id: aTSid) ifNil: [^nil].
	ts := nil.
	tsgen := nil.
	returnSpecific := true.
	request := aRequest.
	explicit := aBoolean.
	(specificId = aTSid and: [specificId formula isGenericFormula])
		ifTrue: [self specificIdAndRequestForGenericTimeSeriesId: specificId
				do: 
					[:myId :myReq |
					genericId := specificId.
					specificId := myId.
					request := myReq.
					explicit := true.
					returnSpecific := false]].
	
	[ts := self
				buildOperatorForRequest: request
				id: specificId
				explicit: explicit.
	tsgen := specificId formula isSpecificToGenericConversion
				ifTrue: [self
						buildForGenericFormulaForRequest: request
						timeSeries: ts
						explicit: explicit]
				ifFalse: [ts].
	specificId formula isLocalizedSchedule
		ifTrue: [(self getHeartbeatSourceAt: specificId formula name)
				subscribe: ts]
		ifFalse: [aRequest currentResource notNil
				ifTrue: [self buildRaBucketsForTimeSeries: tsgen contextResource: request currentResource]
				ifFalse: [nil]]]
		on: Error
		do: 
			[:ex | 
			self
				logBuildErrorForRequest: request
				id: aTSid
				reason: ex.
			(self system debugFlags 
				at: #DEBUG_WALKBACK_ON_BUILD_ERROR
				ifAbsent: [true]) 
					ifTrue: [PvWalkbackWriter new dumpWalkbackForException: ex]].
	^returnSpecific
		ifTrue: [ts ifNil: [self tupleRepository at: specificId]]
		ifFalse:[tsgen ifNil: [self tupleRepository at: genericId]]</body>
</methods>

<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>private</category>

<body package="PV-CME-Core" selector="postBuildActionForTimeSeries:">postBuildActionForTimeSeries: eachTs 
	
	" If a give raw bucket is new, or its subelement had some recent change (i.e. its group membership changed
	directly or indirectly), we need to rebuild its RA buckets. Prior to rebuilding RA buckets we reset flags for all 
	existing buckets so we can scavenge obsolete ones at the end "

	(eachTs formula isSpecificToGenericConversion not and: 
		[eachTs formula isLocalizedSchedule not and: 
			[eachTs isNew or: [(self resyncAgent dirtySubelements includes: eachTs resource) or: [self resyncAgent fullTreeBuildFlag]]]]) 
				ifTrue: 
					[self 
						buildRaBucketsFromRequest: eachTs request
						timeSeries: eachTs]</body>
</methods>


<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initialize">initialize

	super initialize.
	self
		shouldFire: true;
		periodsPerHour: 0;
		metricRecordsCount: 0;
		duplicateRecordCount: 0;
		droppedRecordCount: 0.</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>recomputations</category>

<body package="PV-CME-Core" selector="handleRecomputationRecord:">handleRecomputationRecord: aRecompRecord

	self bufferedTuples isNil
		ifTrue: [self bufferedTuples: OrderedCollection new].

	aRecompRecord isActionDelete
		ifTrue: [self deleteTupleWith: aRecompRecord]
		ifFalse: [self insertOrUpdateTupleWith: aRecompRecord]</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>clients interaction</category>

<body package="PV-CME-Core" selector="lastScavengeableTuplePositionEarlierThan:">lastScavengeableTuplePositionEarlierThan: aNumber 
	
	| pos |
	pos := 
		self clients 
			inject: nil
			into: 
				[:lastPos :eachClient | 
				eachClient firstNeededTupleId 
					ifNil: [lastPos]
					ifNotNil: 
						[:num | 
						lastPos 
							ifNil: [num - 1]
							ifNotNil: [num - 1 min: lastPos]]].
	(pos notNil and: [self shouldStore]) 
		ifTrue: 
			[[pos &gt; 0 and: [(self bufferedTuples at: pos) timestamp &gt;= aNumber]] 
				whileTrue: [pos := pos - 1]]
		ifFalse: 
			[(self isPeriodicTimeSeries or: [pos isNil]) 
				ifTrue: 
					[pos := self bufferedTuples size.
					[pos &gt; 0 and: [(self bufferedTuples at: pos) timestamp &gt;= aNumber]] 
						whileTrue: [pos := pos - 1]]].
	^pos max: 0</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>flags</category>

<body package="PV-CME-Core" selector="shouldFireFlagMask">shouldFireFlagMask

	^2r00010000</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>shouldFire flag</category>

<body package="PV-CME-Core" selector="clearShouldFireFlag">clearShouldFireFlag

	flags := flags maskClear: self shouldFireFlagMask</body>

<body package="PV-CME-Core" selector="shouldFire">shouldFire

	^(flags bitAnd: self shouldFireFlagMask) ~= 0</body>

<body package="PV-CME-Core" selector="setShouldFireFlag">setShouldFireFlag

	flags := flags maskSet: self shouldFireFlagMask</body>

<body package="PV-CME-Core" selector="shouldFire:">shouldFire: aBool

	aBool
		ifTrue: [self setShouldFireFlag]
		ifFalse: [self clearShouldFireFlag]</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>updating</category>

<body package="PV-CME-Core" selector="onAddTuple:">onAddTuple: aTuple 
	" New tuple is produced by the owner of this time series. 
	Store the tuple in the tupleRepository and distribute it to the local clients "

	"Ask the operator if this tuple should be deduplicated"	
	self operator ifNotNil: 
		[:aFormulaOperator | 
		(aFormulaOperator shouldDeduplicateOnAddTuple: aTuple) 
			ifTrue: [^aFormulaOperator deduplicateTuple: aTuple] 
			ifFalse: [aFormulaOperator onAddTuple: aTuple]].

	self tupleRepository 
		addTupleNoUpdate: aTuple
		forTimeSeries: self.
	self tupleRepository 
		changed: #onMetric
		with: aTuple.
	self onUpdateTuple: aTuple</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="flagSpecs">flagSpecs

	^super flagSpecs, #(#(shouldFire shouldFireFlagMask))</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>user interface</category>

<body package="PV-CME-Core" selector="inspectorChildren">inspectorChildren

	| coll details moreDetails operatorLabel liveTsAssoc coll1 |
	details := OrderedCollection new.
 	moreDetails := OrderedCollection new.
	moreDetails
		add: (ObjectLabel on: self id formula);
		add: (ObjectLabel on: self id resource).
	self tupleRepository ifNotNil: [:rep | |specificNode|
		rep 
			specificTimeseriesFor: self 
			do: [:eachSpecificTs |
				specificNode := ObjectLabel key: 'Specific: ', eachSpecificTs pvTreeViewLabelString value: eachSpecificTs.
				details add: specificNode]
	].
	self owner 
		ifNotNil: 
			[:operator |
			operatorLabel := ObjectLabel key: 'Operator-', operator pvTreeViewLabelString value: operator.
			(operator respondsTo: #timeSeriesInputsDo:)
				ifTrue: 
					[operator timeSeriesInputsDo: [:input | details add: input].
					moreDetails add: operatorLabel]
				ifFalse: [details add: operatorLabel]].

	coll := self bufferedTuples ifNil: [#()].
	coll isEmpty
		ifTrue: 
			[self owner 
				ifNotNil: 
					[:operator | 
					operator lastTuple 
						ifNotNil: [:tuple | details add: (ObjectLabel key: 'Last record: ', tuple printString)]].
		]
		ifFalse: 
			[coll1 := OrderedCollection new: coll size.
			coll reverseDo: [:eachRec | 
				coll1 add: (ObjectLabel key: eachRec shortDigest value: eachRec)].
			details add: 
				((HierarchicalObjectWrapper 
					key: 'Records: '
					value: coll1)
					inspectorChildren: coll1;
					emphasis: #(veryDarkGray);
					icon: ListIconLibrary collection16x16;
					yourself)].
	" Add reference to the remote original time series if we are not local"
	self isLocalStreamLabel
		ifFalse: 
			[[liveTsAssoc := self getMyTimeSeries.
			details add: (ObjectLabel key: liveTsAssoc key value: liveTsAssoc value)] valueQuietly].

	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	
	self streamLabel 
		ifNotNil: 
			[:obj | 
			(moreDetails
				add: (ObjectLabel key: 'Label: ' , obj printString value: obj);
				yourself) asArray].
	details add: 
		((HierarchicalObjectWrapper key: 'More for (', self pvTreeViewLabelString, '...', ')' value: self)
			inspectorChildren: moreDetails asArray;
			icon: ListIconLibrary collection16x16;
			emphasis: #(veryDarkGray italic);
			yourself).
	^details asArray</body>
</methods>


<methods>
<class-id>PROVISO.FormulaInstallerApplication</class-id> <category>hooks</category>

<body package="PV-CME-Core" selector="hookStart">hookStart

	| out result |
	out := OS.Stdout.
	super hookStart.
	self dbSession connect.
	self dbSession isConnected ifFalse: 
		[out nextPutAll: 'Unable to establish DB connection, exiting.'; cr.
		^self stopImmediate].
	self dbSession begin.
	result := [
		self formulaDocuments
			do: [ :doc |
				OS.Stdout 
					nextPutAll: 'Processing ';
					nextPutAll: (doc asFilename asString);
					cr.
				FormulaSet 
					installFromFile: doc asFilename 
					infoOn: out]
			separatedBy: [OS.Stdout cr].
		true]
	on: Error do: [:signal |
		self logError: signal description.
		OS.Stdout 
			nextPutAll: 'Error: ';
			nextPutAll: signal description;
			cr.
		signal return: false].

	result
		ifTrue: [self dbSession commit]
		ifFalse: [self dbSession rollback].
	self stopImmediate.</body>
</methods>


<methods>
<class-id>PROVISO.PvInputAndTimeSeriesBuildCommand</class-id> <category>building</category>

<body package="PV-CME-Core" selector="buildTimeSeriesForMsid:metricId:resourceId:label:requestId:isExplicit:withBuilder:">buildTimeSeriesForMsid: msid
	metricId: metricId
	resourceId: resourceId
	label: label
	requestId: requestId
	isExplicit: isExplicit
	withBuilder: aPlanBuilder

	" Build time series and everything necessary for the specified time series. If some required domain
	object (formula, subelement, request) are missing, build inactive stuibs for these "

	| id metric ts resource request tsgen |
	resource := aPlanBuilder pvModel subelementManager getOrCreateNewInactiveItemWithId: resourceId.
	metric := (aPlanBuilder pvModel formulaOrLocalizedScheduleWithId: metricId) ifNil: 
		[self pvModel formulaManager getOrCreateNewInactiveItemWithId: metricId].
	id := MetricSeriesIdentifier msid: msid metric: metric resource: resource.
	request := self pvModel requestManager getOrCreateNewInactiveItemWithId: requestId.
	ts := 
		aPlanBuilder 
			buildOperatorForRequest: request
			id: id
			explicit: isExplicit.
	ts streamLabel: label.
	tsgen := 
			id formula isSpecificToGenericConversion 
				ifTrue: 
					[aPlanBuilder 
						buildForGenericFormulaForRequest: request
						timeSeries: ts
						explicit: isExplicit]
				ifFalse: [ts].
	id formula isLocalizedSchedule 
		ifTrue: [(aPlanBuilder getHeartbeatSourceAt: id formula name) subscribe: ts].
	aPlanBuilder tupleRepository atMsid: id msid put: ts.
	^ts</body>

<body package="PV-CME-Core" selector="addOrUpdatePlanDataWithBuilder:">addOrUpdatePlanDataWithBuilder: aTreeBuilder 
	
	| operatorTs inputTs |
	operatorTs := 
		self 
			buildTimeSeriesForMsid: self ownerTimeSeriesMsid
			metricId: self ownerMetricId
			resourceId: self ownerResourceId
			label: self ownerTimeSeriesLabel
			requestId: self ownerRequestId
			isExplicit: (aTreeBuilder isMyLabel: self ownerTimeSeriesLabel)
			withBuilder: aTreeBuilder.
	operatorTs shouldFire: (aTreeBuilder isMyLabel: self ownerTimeSeriesLabel).
	inputTs := 
		self 
			buildTimeSeriesForMsid: self inputTimeSeriesMsid
			metricId: self inputMetricId
			resourceId: self inputResourceId
			label: self inputTimeSeriesLabel
			requestId: self inputRequestId
			isExplicit: (aTreeBuilder isMyLabel: self inputTimeSeriesLabel)
			withBuilder: aTreeBuilder.
	inputTs shouldFire: (aTreeBuilder isMyLabel: self inputTimeSeriesLabel).
	operatorTs formula formulaPrototype ifNotNil: 
		[:formula | | contextResource |
		contextResource := self contextResourceId isNil
			ifTrue: [nil]
			ifFalse: [aTreeBuilder pvModel subelementManager getOrCreateNewInactiveItemWithId: self contextResourceId].
		formula 
			addOrUpdateInputForTs: operatorTs
			inputTs: inputTs
			sequenceNumber: self sequenceNumber
			versionDate: self versionDate
			currentResource: contextResource
			withBuilder: aTreeBuilder]</body>
</methods>


<methods>
<class-id>PROVISO.PvPlanBasedPropertyManager</class-id> <category>As yet unclassified</category>

<body package="PV-CME-Core" selector="resyncUpdateFrom:">resyncUpdateFrom: aProperty 
	
	self addItem: aProperty.</body>
</methods>

<methods>
<class-id>PROVISO.PvPlanBasedPropertyManager</class-id> <category>resync support</category>

<body package="PV-CME-Core" selector="resyncInsertFrom:">resyncInsertFrom: aProperty 
	
	self addItem: aProperty.</body>
</methods>


<methods>
<class-id>PROVISO.StreamLabelProcessor</class-id> <category>processing (recomputations)</category>

<body package="PV-CME-Core" selector="localCopyOf:">localCopyOf: aRecompAction

	| record |
	(aRecompAction classObject name == #RecomputationAction)
		ifFalse: [^aRecompAction].

	record := PvRecomputationRecord0407 new
		metricId: aRecompAction metricId;
		resourceId: aRecompAction resourceId;
		referenceDate: aRecompAction timestamp;
		value: (Double readFromString: aRecompAction valueString);
		yourself.

	aRecompAction isUpdate
		ifTrue: [record beActionUpdate].

	aRecompAction isInsert
		ifTrue: [record beActionInsert].

	aRecompAction isDelete
		ifTrue: [record beActionDelete].

	^record</body>

<body package="PV-CME-Core" selector="getNearRealTimeRecordsForMid:rid:from:to:">getNearRealTimeRecordsForMid: mid rid: rid from: startTime to: endTime

	^self getMetricRecordsBetween: startTime  and: endTime forMetricId: mid andResourceId: rid</body>

<body package="PV-CME-Core" selector="protectedHandleRecomputationRecords:whileGettingTuplesForMid:rid:from:to:">protectedHandleRecomputationRecords: recompActions whileGettingTuplesForMid: mid rid: rid from: startTime to: endTime

	| answer tsRecords nrtRecords |
	[
		| timeSeries tupleStorageNode needToUseTS |
		mid notNil
			ifTrue: [
				"First, see if we have any NRT records"
				timeSeries := self tupleRepository atMid: mid rid: mid ifAbsent: [nil].
				nrtRecords := (timeSeries notNil and: [timeSeries shouldStore])
					ifTrue: [self getNearRealTimeRecordsForMid: mid rid: rid from: startTime to: endTime]
					ifFalse: [nil].
				nrtRecords isNil
					ifTrue: [needToUseTS := true]
					ifFalse: [
						| earliestRecord |
						earliestRecord := nrtRecords first.
						"If there's a possible gap between NRT and the startTime, we have to go to TS..."
						needToUseTS := earliestRecord timestamp &gt; startTime].
				needToUseTS
					ifTrue: [
						tupleStorageNode := self tupleStorage lookupNode: self collectorNumber ifAbsent: [nil].
						tsRecords := tupleStorageNode isNil
							ifTrue: [nil]
							ifFalse: [tupleStorageNode remoteGetTuplesForMid: mid rid: rid from: startTime to: endTime]]].
		recompActions do: [:each | self handleRecomputationRecord: (self localCopyOf: each)]] valueUninterruptably.

	answer := OrderedCollection new.
	tsRecords notNil
		ifTrue: [answer addAll: tsRecords].
	nrtRecords notNil
		ifTrue: [answer addAll: nrtRecords].

	^ReadStream on: answer</body>
</methods>


<methods>
<class-id>PROVISO.CmeSmeeFormulaBuildHelper</class-id> <category>private</category>

<body package="PV-CME-Core" selector="bindInputsForRequest:operator:formula:">bindInputsForRequest: aRequest operator: operator formula: aFormula 
	" Build operator inputs. Each input is specified as a path with potentially multiple segments. 
	Each segment is a formula name or a calendar reference. All intermediate segments should refer
	to a relation-typed formula; the leaf segment should refer to a float, string or property formula.
	For all intermediate segments we have to build intermediate nodes in case the topology in the middle 
	changes. For the leaf segment we build an instace of Input for specified formula and the resource we
	navigate to from the current operator via relation formula segments
	"
	
	| oldInputs oldIntermediates newInputs |
	oldInputs := operator inputs ifNil: [self class emptySet].
	newInputs := (Array new: aFormula arguments size).
	oldIntermediates := operator intermediateNodes copy.
	operator intermediateNodes: Set new.

	aFormula arguments keysAndValuesDo: 
		[:ix :eachArgument | | oldInput newInput|
		oldInput := oldInputs detect: [:each | each notNil and: [each sequenceNumber = eachArgument id]] ifNone: [nil].
		newInput := nil.
		self builder 
			convertInputPath: eachArgument pathFormulas
			startingFrom: 1
			toIdsForResouce: operator resource
			do: 
				[:eachTSid :leaf |
				"formula can be nil if the formula was removed from the system but still remains in some other formula's pathFormulas"
				eachTSid formula ifNotNil:
					[leaf 
						ifTrue: 
							[eachTSid resource isActive ifTrue: [
								 newInput := 
									self 
										buildInputForRequest: aRequest
										operator: operator
										input: oldInput
										newInput: newInput
										id: eachTSid.
								newInput ifNotNil: [newInput sequenceNumber: eachArgument id]]]
						ifFalse: 
							[self builder 
								buildIntermediateTimeSeriesForOperator: operator
								id: eachTSid]]].

		"make the newInputs at this argument be the newInputs we just created"
		newInputs at: ix put: newInput].

		"disconnect old inputs that are no longer needed because formula changed"
		oldInputs do: 
			[:oInputs | 
			oInputs ifNotNil: 
				[oInputs do: 
					[:oldInput | 
					(self hasInput: oldInput in: newInputs) 
						ifFalse:
							[self builder changed: #aboutToDeleteInput with: oldInput.
							oldInput disconnect]]]].
	
	oldIntermediates 
		ifNotNil: 
			[oldIntermediates do: 
				[:eachInput | 
				(operator includesIntermediate: eachInput) 
					ifFalse: [operator removeIntermediate: eachInput]]].

	"set the operator's inputs to be the newInputs (the ones we just created or reused)"
	operator inputs: newInputs.
	aFormula arguments 
		with: operator inputs
			do: 
				[:arg :input | 
				operator 
					smeeAt: arg name
					put: input].
	operator removeSmeePropertiesForObsoleteFormulaInputs</body>
</methods>


<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="specificTimeseriesFor:do:">specificTimeseriesFor: aTimeSeries do: aBlock 
	
	aTimeSeries formula isSpecificToGenericConversion 
		ifFalse: 
			[self pvModel formulaManager 
				formulasWithGenericId: aTimeSeries metricId
				do: 
					[:formula | 
					(self metricTimeSeries 
						atMid: formula id
						rid: aTimeSeries resourceId) ifNotNil: [:specificTs | aBlock value: specificTs]]]</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>accessing trees</category>

<body package="PV-CME-Core" selector="rawBucketsKeysAndValuesDo:">rawBucketsKeysAndValuesDo: aBlock

	self rawData keysAndValuesDo: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>api</category>

<body package="PV-CME-Core" selector="addHeartbeatBufferedTuple:for:">addHeartbeatBufferedTuple: aMetricRecord for: cmeTimeSeries

	heartbeatBuffer
		atMid: cmeTimeSeries metricId
		rid: cmeTimeSeries resourceId
		put: (Array with: aMetricRecord with: cmeTimeSeries).</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>private</category>

<body package="PV-CME-Core" selector="injectBufferedTuplesIntoComputationsUntilAllDone">injectBufferedTuplesIntoComputationsUntilAllDone

	| formulasInBuffer inputFormulaIds tupleToTsList |	
	
	tupleToTsList := OrderedCollection new: heartbeatBuffer size.
	[heartbeatBuffer isEmpty]
		whileFalse:
			["build up a list of all formulas in the buffer"
			formulasInBuffer := Set new: 200.
			heartbeatBuffer do: [:array | formulasInBuffer add: array last formula].

			"find the formulaIds that do not depend on any other formulas in the buffer"
			inputFormulaIds := Set new: 200.
			formulasInBuffer do: 
				[:each | 
				(formulasInBuffer noneSatisfy: [:each2 | each dependsOnFormula: each2])
					ifTrue: [inputFormulaIds add: each id]].
		
			"build up a list of all timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList fastEmpty.
			heartbeatBuffer keysAndValuesDo: 
				[:midRidArray :tupleToTsArray | 
				(inputFormulaIds includes: midRidArray first)
					ifTrue: [tupleToTsList add: tupleToTsArray]].
	
			"remove the timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				heartbeatBuffer 
					removeMid: tupleToTsArray second metricId 
					rid: tupleToTsArray second resourceId 
					ifAbsent: []].
	
			"do onAddTuple: for each timeseries where the formula does not depend on any other formulas in the buffer.
			For tupleWindow type formulas this can result in more things being added to heartbeatBuffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				tupleToTsArray last onAddTuple: tupleToTsArray first]]</body>
</methods>


<class>
<name>CmlSerializer</name>
<environment>PROVISO</environment>
<super>PROVISO.SimpleSerializer</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>currentTupleSource operatorCount timeSeriesCount tupleCount tupleRepository skipTupleSourceFlagsOnRead </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.CmlSerializer</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initialize">initialize

	super initialize.
	timeSeriesCount := 0.
	operatorCount := 0.
	tupleCount := 0.
	skipTupleSourceFlagsOnRead := true.</body>
</methods>

<methods>
<class-id>PROVISO.CmlSerializer</class-id> <category>reading</category>

<body package="PV-CME-Core" selector="readHeartbeatSource:">readHeartbeatSource: aHeartbeatSource

	| periodStart duration source |
	periodStart := self read.
	duration := self read.

	source := self tupleRepository heartbeatHandlerAt: aHeartbeatSource id ifAbsent: [^nil].
"mkam commented out for RA503363
because state restore was messing up localizedSchedules even
thought resync had changed the cal from month to day"
	"source start: periodStart length: duration."
	^source</body>

<body package="PV-CME-Core" selector="readCalendarSource:">readCalendarSource: aHeartbeatSource 
	
	| source |
	source := self readHeartbeatSource: aHeartbeatSource.
"mkam commented out for RA503363
because state restore was messing up localizedSchedules even
thought resync had changed the cal from month to day"
	"source ifNotNil: 
		[source policy
			intervalForTimestamp: source endOfPeriod;
			intervalForTimestamp: source startOfPeriod]"</body>

<body package="PV-CME-Core" selector="readTupleSource:">readTupleSource: aTupleSource

	timeSeriesCount := timeSeriesCount + 1.
	[currentTupleSource := aTupleSource.
	skipTupleSourceFlagsOnRead
		ifTrue: [self read]
		ifFalse: [	aTupleSource flags: self read].
	"We only write the owner if it is a formula operator, otherwise, we write a nil, so only set the owner if it's not nil"
	self read ifNotNil: [ :obj | aTupleSource owner: obj].
	^aTupleSource]
			ensure: [currentTupleSource := nil]</body>
</methods>


<methods>
<class-id>PROVISO.AbstractPlanBasedTreeBuilder</class-id> <category>As yet unclassified</category>

<body package="PV-CME-Core" selector="deleteTimeSeriesForMsid:mid:rid:">deleteTimeSeriesForMsid: anMsid mid: metricId rid: resourceId 

	" Remove stuff looking up only by msid "

	" First, by msid "
	self tupleRepository atMsid: anMsid 
		ifPresent: [:presentTimeSeries |
			(presentTimeSeries metricId ~= metricId or: [presentTimeSeries resourceId ~= resourceId])
				ifTrue: 
					[self system logWarning: #TIME_SERIES_ID_CHANGE
						messageId: #DC100901
						template: 'Time series being deleted: &lt;1p&gt; is registered under msid &lt;2p&gt; as mid=&lt;3p&gt;, rid=&lt;4p&gt;'
						arguments: (Array with: presentTimeSeries id with: anMsid with: metricId with: resourceId)].
			self tupleRepository removeMsid: presentTimeSeries msid.
			presentTimeSeries disconnect]
		ifAbsent: [].</body>
</methods>


<class>
<name>MockRequestEnumerator</name>
<environment>PROVISO</environment>
<super>PROVISO.CmeESTreeBuilder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>requests matchBlock prunerClass </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>enumerating</category>

<body package="PV-CME-Core" selector="do:">do: aBlock 

	self requests do: 
		[:request | 
		aBlock 
			value: request
			value: request target]</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initialize">initialize
	
	super initialize.
	requests := OrderedCollection new.
	self beForAssociations.
	prunerClass := CmeESTreePruner</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="replaceAssociationsWith:">replaceAssociationsWith: aCollection

	self associations: aCollection</body>

<body package="PV-CME-Core" selector="beForAssociations">beForAssociations
	
	matchBlock := 
		[:arr :node | 
		self requests noneSatisfy: 
			[:eachRequest | eachRequest formula id = arr first and: [eachRequest target id = arr last]]]</body>

<body package="PV-CME-Core" selector="beForIncrementalTreeBuild">beForIncrementalTreeBuild

	self matchBlock: [:arr :bucket | 
		self pvModel resyncAgent dirtySubelements anySatisfy: [:eachSe | eachSe id = arr last]].</body>

<body package="PV-CME-Core" selector="resources">resources

	^IdentitySet new
		addAll: (self requests collect: [:each | each target]); 
		yourself</body>

<body package="PV-CME-Core" selector="emulateCmeTreeBulder">emulateCmeTreeBulder
	
	self matchBlock: 
		[:arr :bucket | 
		self fullTreeBuildFlag or: 
			[self pvModel resyncAgent dirtySubelements anySatisfy: 
				[:eachSe | eachSe id = arr last]]]</body>

<body package="PV-CME-Core" selector="formulas">formulas 
	
	^IdentitySet new addAll: (self requests collect: [:each | each formula])</body>

<body package="PV-CME-Core" selector="requests:">requests: aCollection

	requests := aCollection</body>

<body package="PV-CME-Core" selector="requests">requests

	^requests</body>

<body package="PV-CME-Core" selector="associations:">associations: aCollection 
	
	self pvModel requestManager
		initialize; 
		relink.
	self requests: (aCollection collect: [:assoc | self newRequestForFormula: assoc key resource: assoc value])</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>building</category>

<body package="PV-CME-Core" selector="build">build

	PvFormulaLinker linkFormulas: (self requests collect: [:e | e formula]) inPvModel: self pvModel.
	super build</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>private</category>

<body package="PV-CME-Core" selector="newRequestForFormula:resource:">newRequestForFormula: aFormula resource: aSubelement

	| request |
	request := 
		PvRequest new
			id: self pvModel getNextId; 
			targetType: 'alias'; 
			target: aSubelement; 
			targetIndex: aSubelement id; 
			period: 900; 
			status: 'active'; 
			storageState: 'always'; 
			origin: 'Smalltalk'; 
			formulaIndex: aFormula id; 
			formula: aFormula; 
			yourself.
	self pvModel requestManager addItem: request.
	^request</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>timeSeriesToRequests</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>timeSeriesToRequests:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>associationsToIgnore</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>associations</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>newRequestForFormula:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>associationsToIgnore:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>associateTimeSeries:withRequest:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.SlePlanBasedBuilder</class-id> <category>private</category>

<body package="PV-CME-Core" selector="buildResourceBuckets">buildResourceBuckets
	" Since we are building the tree ebfore we have resources, we cannot build RA/GA buckets
	until after we completed loading all the resources. Therefore we disable building RA/GA buckets initially "
	
	| metadataTime1 buildTime1 metadataTime2 buildTime2 |

	"Mark all ts as old so that we know what is new"
	self rawData do: [:timeSeries | timeSeries beOld].

	self shouldBuildRaAndGaBuckets: false.
	self resyncAgent resync: 
		[self resyncAgent markCurrentObjects.		" This is how we will know which resources are new "
		metadataTime1 := 
			Time millisecondsToRun: [self resyncGlobalMetadata].
		buildTime1 := Time millisecondsToRun: 
			[self recompileTimeSeriesForFormulaChanges.
			self buildExternalTimeSeries.
			self buildTimeSeriesAndInputs.
			self processTimeSeriesDeletes].
		metadataTime2 := Time millisecondsToRun: 
			[" Populate resource id temp table which will drive resynching of all resource-related data "
			self populateTempTable.
			" Now resync all the interesting resource details "
			self resyncAgent 
				resyncFromResourcesDomainManagers: 
						#(elementManager subelementManager propertyManager thresholdManager relationManager)
					between: self metadataStartSeconds
					and: self metadataEndSeconds;
				lastStartSeconds: self metadataStartSeconds;
				lastEndSeconds: self metadataEndSeconds]].
	buildTime2 := Time millisecondsToRun: [self buildRaBuckets].
	self stats
		timingFor: #preHourlyLoadMetadataSeconds
		is: (metadataTime1 + metadataTime2) // 1000.
	self stats
		timingFor: #preHourlyTreeBuildSeconds
		is: (buildTime1 + buildTime2) // 1000.</body>

<body package="PV-CME-Core" selector="recompileTimeSeriesForFormulaChanges">recompileTimeSeriesForFormulaChanges
	"by default everything is marked and we only clear things when we know they need to go away"
	
	| formulasToReshape |
	self pvFlag: #TODO.
	" What to do if a formula changes from Smee to Smalltalk or vice versa "
	formulasToReshape := 
		self resyncAgent updatedFormulas select: 
			[:eachPvFormula | eachPvFormula isOperatorFormula and: [eachPvFormula isSmeeFormula]].

	formulasToReshape notEmpty 
		ifTrue: 
			[self rawBucketsDo: 
				[:eachTs | 
				(eachTs owner notNil and: [formulasToReshape includes: eachTs formula]) 
					ifTrue: [eachTs owner recompileWithFormula: eachTs formula formulaPrototype]]]</body>

<body package="PV-CME-Core" selector="buildgroupBuckets">buildgroupBuckets
	
	self shouldBuildRaAndGaBuckets: true.
	super buildgroupBuckets.
	self shouldBuildRaAndGaBuckets: false.</body>

<body package="PV-CME-Core" selector="buildRaBuckets">buildRaBuckets
	
	| time |	
	self shouldBuildRaAndGaBuckets: true.
	self system 
		logDebugTwo: #CME_PLAN_STEP 
		text: 'Building RA buckets'. 
	time := 
		Time millisecondsToRun: 
			[self rawData do: 
				[:timeSeries | | hasContextChanged |
				"Determine all the contexts in which you need to rebuild this time series's RAs in.
				This might include timeSeries resource or any of its context resources if they are dirty "
				hasContextChanged := timeSeries isNew or: [self resyncAgent fullTreeBuildFlag].
				hasContextChanged 
					ifFalse: 
						[timeSeries contextResourcesDo: 
							[:eachResource | 
							(self resyncAgent dirtySubelements includes: eachResource) 
								ifTrue: [hasContextChanged := true]]].
				"If any of our contexts have changed then unmark all ras for this timeseries and rebuild 
				them for each contextResource &amp; the timeSeries resource"
				hasContextChanged
					ifTrue:
						[timeSeries prepareDependentRaRecordsForUpdate.
						timeSeries contextResourcesDo: 
							[:eachResource | 
							self
								buildRaBucketsForTimeSeries: timeSeries
								contextResource: eachResource]]]].
	self shouldBuildRaAndGaBuckets: false.
	self system
		logDebugTwo: #CME_PLAN_STAT 
		text: 'Finished building RA buckets in ', (time // 1000) printString, ' seconds'.</body>
</methods>

<methods>
<class-id>PROVISO.SlePlanBasedBuilder</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="planEndSeconds">planEndSeconds
	" Plan time to resync "

	^self endSeconds</body>

<body package="PV-CME-Core" selector="planStartSeconds">planStartSeconds
	" Plan time to resync "

	^self startSeconds</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.SlePlanBasedBuilder</class-id> <selector>clearBuckets</selector>
</remove-selector>


<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>state save/restore</category>

<body package="PV-DC-Plan-Builder" selector="upgradeStateFromKilaToLulu">upgradeStateFromKilaToLulu
	
	| dl stateDir |
	self fileInterface stateDirectory copyDirectoryTo: 
		(self fileInterface subsystemDirectory construct: 'backupOfStateBeforeUpgrade').
	self
		restoreState;
		saveAdvanceCollectorRequestsState;
		saveStateLabelChangeHistory;
		saveVersionBeingBuilt: self versionBeingBuilt
			advanceCollectorRequests: 
				(self advancingCollectorLabels asArray collect: 
					[:e | 
					e id -&gt; e collectorTimeNow]);
		saveStateVersionLastBuilt.
	self advancingCollectorLabels do: [:e | e collectorTimeNow: e collectorTimeInPlan].
	(dl := 
		PblPlanAndMetadataDumperLoader 
			forVersion: self versionLastBuilt
			planBuilder: self)
		makeVersionDirectory;
		saveOperatorState;
		saveCollectorState.
	stateDir := self fileInterface stateDirectory.
	dl planAndMetadataFilenames do: [:each | self fileInterface moveFilename: stateDir , each tail toFilename: each].
	(stateDir , 'planVersion.state') exists 
		ifTrue: [(self fileInterface stateDirectory construct: 'planVersion.state') delete].
	self planBuilderStateFilename delete</body>
</methods>

<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>plan building</category>

<body package="PV-DC-Plan-Builder" selector="buildPlan:">buildPlan: aBlock 
	"PlanBuilderApplication new startWithCommandLine: 'vm image -a PBL -name PBL -f ../conf/dc.cfg '  "
	
	| hadChanges dl |
	self versionBeingBuilt
		ifNil: [self setAdvancementsForVersionBeingBuilt].
	
	hadChanges := false.
	dl := PblPlanAndMetadataDumperLoader forVersion: self versionBeingBuilt planBuilder: self.
	self initiateCollectorAdvancement.
	self logAboutToUpdatePlan.
	self advancingCollectorLabels isEmpty 
		ifTrue: [self logNoMeaningfulAdvancements]
		ifFalse: 
			[aBlock 
				ifNil: 
					[self updateMetadata: false.
					self buildAndPruneTrees.
					self saveLabelRelationshipsToDatabase.
					hadChanges := self planSaver hasChanges.
					self savePlanToDatabase]
				ifNotNil: 
					[aBlock value.
					hadChanges := self planSaver hasChanges]].
	self completeCollectorAdvancement.
	
	"Save in the main state dir"
	self saveStateLabelChangeHistory.

	"Save all these files in the versionBeingBuilt directory"
	dl
		makeVersionDirectory;
		saveCollectorState;
		saveOperatorState;
		dumpCachedPlanAndMetadata;
		recordPlanRowsInserted: hadChanges.

	"Once we do this it is comitted.  If we don't do this then when PBL 
	restarts we will wipe out the plan and state from disk for the version 
	being built and start over"
	self resetAdvancementsForVersionBeingBuilt.

	"Now that it is committed, go delete big state files from previous versions 
	and make sure we only keep around the most recent N versions of state"
	dl deletePlanAndMetadataFromDiskForAllPreviousVersions.</body>

<body package="PV-DC-Plan-Builder" selector="handleBuiltGenericTimeSeries:for:">handleBuiltGenericTimeSeries: genericTs for: specificTs 
	"A ts for a generic formula should have the same label as the specific formula's ts"	

	| cNum labelToAssign specificLabels | 
	cNum := self getCollectorNumberForTimeSeries: genericTs.
	labelToAssign :=
		(cNum isNil or: [cNum = 0])
			ifTrue: [self operatorLabelZero]
			ifFalse: [self collectorLabelForId: cNum].

	specificLabels := Set new.
	genericTs formula specificFormulas do: 
		[:specificFormula | 
		(self atMid: specificFormula id rid: genericTs resourceId) ifNotNil: 
			[:ts | specificLabels add: ts streamLabel]].
	specificLabels size = 1
		ifTrue: [labelToAssign := specificLabels anyOne]
		ifFalse: 
			[specificLabels size &gt; 1 
				ifTrue: [self logMultipleSpecific: specificLabels toGeneric: genericTs]].

	self 
		changeLabelForTimeSeries: genericTs 
		to: labelToAssign</body>
</methods>

<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>logging</category>

<body package="PV-DC-Plan-Builder" selector="logNoMeaningfulAdvancements">logNoMeaningfulAdvancements

	self system 
		logInfo: #NO_MEANINGFUL_ADVANCEMENTS
		messageId: nil
		text: 'There were no meaningful collector advancements.  Skipping metadata resync, tree build, db save'.</body>

<body package="PV-DC-Plan-Builder" selector="logSavePlanError">logSavePlanError
	&lt;comment: 'Stopping plan builder because plan save to db failed' 
	probableCause: 'Could be duplicate rows, database error, Smalltalk exception, or something else'
	suggestedAction: 'Restart the plan builder'&gt;

	self system 
		logWarning: #PLAN_SAVE_ERROR
		messageId: #DC10009
		text: 'Stopping plan builder because plan save to db failed'.</body>

<body package="PV-DC-Plan-Builder" selector="logMultipleSpecific:toGeneric:">logMultipleSpecific: specificLabels toGeneric: aTimeSeries

	| specificFormulas |
	specificFormulas := (aTimeSeries specificFormulas collect: [:e | e nameString]) asArray.
	self system
		logWarning: #MULTIPLE_SPECIFIC_TO_GENERIC
		messageId: #DC10010
		text: 'There are multiple specific formulas: ', specificFormulas printString ,' for this generic formula: ' , aTimeSeries id printString , '. These specific formulas are for the same resource and reside in different labels ', specificLabels asArray printString.</body>
</methods>


<methods>
<class-id>PROVISO.PblPlanFromDatabaseBuilder</class-id> <category>private</category>

<body package="PV-DC-Plan-Builder" selector="buildResourceBuckets">buildResourceBuckets
	
	|  tsCount inputCount tsWalkbacksWritten inputWalkbacksWritten |

	tsCount := 0.
	tsWalkbacksWritten := 0.
	PlanAccessor new 
		planVersionsPast: self lastLoadedPlanVersion
		timeSeriesDo: 
			[:eachRow | 
			[self buildTimeSeriesFromDbRow: eachRow.
			tsCount := tsCount + 1] 
				on: Error
				do: 	
					[:ex | 
					self logErrorBuildTsErrorFrom: eachRow reason: ex.
					tsWalkbacksWritten &gt; 2 
						ifFalse: 
							[PvWalkbackWriter new dumpWalkbackForException: ex.
							tsWalkbacksWritten := tsWalkbacksWritten + 1]]].
	self system logDebugTwo: #PLAN_STAT text: 'Loaded ' , tsCount asString , ' time series from db'.

"Load inputs"
	inputCount := 0.
	inputWalkbacksWritten := 0.
	PlanAccessor new 
		planVersionsPast: self lastLoadedPlanVersion
		inputsDo: 
			[:eachRow | 
			[self buildInputFromDbRow: eachRow.
			inputCount := inputCount + 1] 
				on: Error
				do: 
					[:ex | 
					self logErrorBuildInputErrorFrom: eachRow reason: ex.
					inputWalkbacksWritten &gt; 2 
						ifFalse: 
							[PvWalkbackWriter new dumpWalkbackForException: ex.
							inputWalkbacksWritten := inputWalkbacksWritten + 1]]].
	self system logDebugTwo: #PLAN_STAT text: 'Loaded ' , inputCount asString , ' inputs from db'.

	"Actually assign each ts it's label"
	self rawData do: 
		[:ts | 
		ts streamLabel assignToTimeSeries: ts]</body>
</methods>


<methods>
<class-id>PROVISO.PlanBuilderTimeSeries</class-id> <category>user interface</category>

<body package="PV-DC-Plan-Builder" selector="inspectorChildren">inspectorChildren

	| coll details moreDetails operatorLabel liveTsAssoc |
	details := OrderedCollection new.
	moreDetails := OrderedCollection new.
	moreDetails
		add: (ObjectLabel on: self id formula);
		add: (ObjectLabel on: self id resource).
	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	self tupleRepository ifNotNil: [:rep | |specificNode|
		rep 
			specificTimeseriesFor: self 
			do: [:eachSpecificTs |
				specificNode := ObjectLabel key: 'Specific: ', eachSpecificTs pvTreeViewLabelString value: eachSpecificTs.
				details add: specificNode]
	].
	self owner 
		ifNotNil: 
			[:operator |
			operatorLabel := ObjectLabel key: 'Operator-', operator pvTreeViewLabelString value: operator.
			(operator respondsTo: #timeSeriesInputsDo:)
				ifTrue: 
					[operator timeSeriesInputsDo: [:input | details add: input].
					moreDetails add: operatorLabel]
				ifFalse: [details add: operatorLabel]].

	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	
	self streamLabel 
		ifNotNil: 
			[:obj | 
			[liveTsAssoc := self getMyTimeSeries.
			moreDetails add: (ObjectLabel key: liveTsAssoc key value: liveTsAssoc value)] valueQuietly.
			moreDetails add: (ObjectLabel key: 'Label: ' , obj printString value: obj).
			moreDetails asArray].
	details add: 
		((HierarchicalObjectWrapper key: 'More for ', self printString, '...' value: self)
			inspectorChildren: moreDetails asArray;
			icon: ListIconLibrary collection16x16;
			yourself).

	^details asArray</body>
</methods>


<methods>
<class-id>PROVISO.PlanAccessor</class-id> <category>pbl support</category>

<body package="PV-DC-Plan-Builder" selector="collectorTimesInPlan:do:">collectorTimesInPlan: collectorNums do: aBlock 

	collectorNums do: 
			[:cNum | | time |
			time := 0.
			[time := (self dbSession
						executeSelect: 'select max(dte_date) from ts_desc where int_label = ' 
								, cNum printString) first first] 
					on: Error
					do: [:err | ].
			time ifNil: [time := 0].
			time := 0 max: time.
			aBlock value: cNum value: time]</body>
</methods>


<methods>
<class-id>PROVISO.PblPlanFromDiskBuilder</class-id> <category>As yet unclassified</category>

<body package="PV-DC-Plan-Builder" selector="buildResourceBuckets">buildResourceBuckets

	| tsCount inputCount tsWalkbacksWritten inputWalkbacksWritten |
	

"Load timeSeries"
	tsCount := 0.
	tsWalkbacksWritten := 0.
	self planBuilder planAndMetadataDumperLoader 
		timeSeriesDo: 
			[:eachRow | 
			[self buildTimeSeriesFromDbRow: eachRow.
			tsCount := tsCount + 1] 
				on: Error
				do: 	
					[:ex | 
					self logErrorBuildTsErrorFrom: eachRow reason: ex.
					tsWalkbacksWritten &gt; 2 
						ifFalse: 
							[PvWalkbackWriter new dumpWalkbackForException: ex.
							tsWalkbacksWritten := tsWalkbacksWritten + 1]]].
	self system logDebugTwo: #PLAN_STAT text: 'Loaded ' , tsCount asString , ' time series from disk'.

"Load inputs"
	inputCount := 0.
	inputWalkbacksWritten := 0.
	self planBuilder planAndMetadataDumperLoader 
		inputsDo: 
			[:eachRow | 
			[self buildInputFromDbRow: eachRow.
			inputCount := inputCount + 1] 
				on: Error
				do: 
					[:ex | 
					self logErrorBuildInputErrorFrom: eachRow reason: ex.
					inputWalkbacksWritten &gt; 2 
						ifFalse: 
							[PvWalkbackWriter new dumpWalkbackForException: ex.
							inputWalkbacksWritten := inputWalkbacksWritten + 1]]].
	self system logDebugTwo: #PLAN_STAT text: 'Loaded ' , inputCount asString , ' inputs from disk'.

	"Actually assign each ts it's label"
	self rawData do: 
		[:ts | 
		ts streamLabel assignToTimeSeries: ts]</body>
</methods>



<methods>
<class-id>PROVISO.RecompServer</class-id> <category>transactions</category>

<body package="PV-DC-Recomputations" selector="handleTupleContainer:">handleTupleContainer: aTupleContainer 

	| theLabel |
	"Reject dups sent from TSE but allow dups sent by me"
	(self isDuplicateContainer: aTupleContainer) 
		ifTrue: [^self rejectDuplicateContainer: aTupleContainer].

	aTupleContainer isForRecomputations
		ifFalse: [
			(RecompCommandLog on: self) transactionDo: [:txn | 
				self releaseNonRecompTupleContainer: aTupleContainer in: txn.
				self updateLastContainerTimestamp: aTupleContainer timestamp in: txn].
			^nil].

	"Now we may need to wait for the CMEs to catch up..."
	[self isReadyForTupleContainer: aTupleContainer]
		whileFalse: [(Delay forSeconds: 60) wait].

	self system extendedStatus: 'Tuple Processing'.
	"Process the entire tuple container as an xlog"
	self logAboutToProcesesTupleContainer: aTupleContainer.
	theLabel := aTupleContainer label.
	(RecompCommandLog on: self) transactionDo: 
		[:txn | | resultsFn bufferFn sourceFn tempFn |
		self releaseProcessedTupleContainer: aTupleContainer in: txn.
		resultsFn := self fileInterface recompResultsStateFilename.
		sourceFn := self fileInterface recompSourceStateFilename.
		tempFn := self fileInterface recompTempFilename.
		bufferFn := self fileInterface outputBufferForTseStateFilename.
		(self isMyContainer: aTupleContainer)
			ifTrue: [
				| tuples |
				tuples := OrderedCollection new.
				aTupleContainer do: [:each | tuples add: each].
				self fileInterface saveRecompTuples: tuples to: tempFn. 
				txn recomputeAll: tempFn saveResultsTo: resultsFn saveActionsTo: sourceFn originLabel: theLabel.
				self handlePostRecomputeIn: txn for: resultsFn and: sourceFn to: bufferFn on: theLabel.
				txn deleteBufferedRecompResult: tempFn]
			ifFalse: [
				aTupleContainer do: [:tuple | 
					tuple isHeartbeat
						ifFalse: [
							txn recompute: tuple saveResultsTo: resultsFn saveActionsTo: sourceFn originLabel: theLabel.
							self handlePostRecomputeIn: txn for: resultsFn and: sourceFn to: bufferFn on: theLabel]]].
		txn outputBufferedRecompResultsToTse: bufferFn.
		txn deleteBufferedRecompResult: bufferFn.
		self updateLastContainerTimestamp: aTupleContainer timestamp in: txn].

	self system extendedStatus: 'Idle'.</body>

<body package="PV-DC-Recomputations" selector="computeScopeFor:on:">computeScopeFor: aTimeSeries on: recomputationActions
	"Determine the scope of the receiver's operation, which involves finding the period of the formula the given time series represents, and then finding the boundaries of that period."

	| startScope endScope scopeStartTimestamp scopeEndTimestamp |
	"Note - We have to do these in reverse order, because part of doing the scope calculation is to resync the formula itself into the model,
	and we need to end up with the original one in the model at the start time, not what was there at the end time..."
	endScope := recompEngine queryInterface
		getScopeFor: aTimeSeries
		timestamp: recomputationActions last timestamp.
	endScope isNil
		ifTrue: [
			self system 
				logDebugTwo: #RECOMP_ERROR
				text: 'No inputs for time series ', aTimeSeries printString, ' at or before ', (PvTimestamp fromSeconds: recomputationActions last timestamp) printString.
			^nil].

	startScope := recomputationActions size = 1
		ifTrue: [endScope]
		ifFalse: [
			self pvModel calendarManager resetLocalizedSchedules.
			recompEngine queryInterface
				getScopeFor: aTimeSeries
				timestamp: recomputationActions first timestamp].
	scopeStartTimestamp := startScope first key.
	scopeEndTimestamp := endScope first value.

	"Since we sometimes end up messing up localized schedules when we compute the scope, we need to reset them."
	self pvModel calendarManager resetLocalizedSchedules.

	^scopeStartTimestamp -&gt; scopeEndTimestamp</body>

<body package="PV-DC-Recomputations" selector="isReadyForTupleContainer:">isReadyForTupleContainer: aTupleContainer
	"Figure out if we can do the recomputation action(s) in the given tuple container. 
	Return true or false to answer the question."

	| recomputationActions affectedTimeSeries cmeTimes referenceDateString returnValue farthestDate |
	"If we don't have any recomp actions, we're done. This should never happen, since we've already tested for this."
	recomputationActions := (aTupleContainer allTuples
		select: [:each | each isRecomputationAction]) asOrderedCollection.

	recomputationActions isEmpty
		ifTrue: [^true].

	"For each affected time series, find the labels, and then ask each one where it is at in the timeline."
	cmeTimes := Dictionary new.
	affectedTimeSeries := recompEngine queryInterface getAffectedTimeSeriesFor: recomputationActions first.
	affectedTimeSeries isEmpty
		ifTrue: [^true].
	farthestDate := Infinity negative.
	affectedTimeSeries do: [:eachTimeSeries |
		| labels scope |
		scope := self computeScopeFor: eachTimeSeries on: recomputationActions.
		scope value: (scope value min: recomputationActions first timestamp).
		farthestDate := farthestDate max: scope value.
		labels := PvTimeSeriesBuildCommand
			labelsForMetricId: eachTimeSeries metricId
			subelementId: eachTimeSeries resourceId
			between: scope key
			and: scope value.
		labels do: [:eachLabel |
			| cmePair |
			cmePair := CMETimeSeries new getApplicationForOperatorLabel: eachLabel asNumber.
			(cmePair value notNil and: [(cmeTimes includesKey: cmePair key) not])
				ifTrue: [
					| cmeApplication currentTime |
					cmeApplication := cmePair value.
					[currentTime := cmeApplication server streamLabelOperator periodPolicy last]
						on: Error do: [:signal | signal return: nil].
					cmeTimes at: cmePair key put: currentTime]]].

	"Compare each label's current position with the scope, and log any that aren't far enough along."
	referenceDateString := (PvTimestamp fromSeconds: farthestDate) printString.
	returnValue := true.
	cmeTimes keysAndValuesDo: [:eachServerName :eachTime |
		eachTime isNil 
			ifTrue: [
				self system 
					logDebugTwo: #RECOMP_NOT_READY
					text: eachServerName, ' is at at an unknown time and needs to be past ', referenceDateString, ' in order to continue with this recomputation.'.
				returnValue := false]
			ifFalse: [
				eachTime &lt; farthestDate
					ifTrue: [
						self system 
							logDebugTwo: #RECOMP_NOT_READY
							text: eachServerName, ' is at ', (PvTimestamp fromSeconds: eachTime) printString, ' and needs to be past ', referenceDateString, ' in order to continue with this recomputation.'.
						returnValue := false]]].

	^returnValue</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationMetadataChangeWrapper</class-id> <category>testing</category>

<body package="PV-DC-Recomputations" selector="isSameAs:">isSameAs: anotherWrapper

	^self record isSameAs: anotherWrapper record</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationAction</class-id> <category>converting</category>

<body package="PV-DC-Recomputations" selector="asRecomputationRecord">asRecomputationRecord

"	record := (PvRecomputationRecord0407
		metricId: self metricId
		resourceId: self resourceId
		date: self timestamp 
		value: self value)	
			referenceDate: 
			beActionDelete;
			yourself"</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationAction</class-id> <category>accessing</category>

<body package="PV-DC-Recomputations" selector="pollId">pollId
	" default implementation for the pollId, is simply the timestamp of the measure within the current hour"
	
	^self date \\ 3600</body>

<body package="PV-DC-Recomputations" selector="valueString">valueString

	^self value printString</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>recomputation</category>

<body package="PV-DC-Recomputations" selector="computeMetadataChangesFor:">computeMetadataChangesFor: aTimeSeries
	"Determine the initial metadata setup for the given time series. That includes inputs, and the time series for those inputs. Also keep track of the time series separately, we use those to gather metric records."

	metadataChanges := SortedCollection
		with: (RecomputationAddTimeSeriesWrapper on: aTimeSeries from: scopeStartTimestamp to: scopeEndTimestamp).
	inputsByTime := OrderedCollection new.

	mergedInputs do: [:eachInputWrapper |
		| timeSeriesWrapper |
		timeSeriesWrapper := RecomputationAddTimeSeriesWrapper
			on: (queryInterface
				getLastTimeSeriesWithId: eachInputWrapper record inputTimeSeriesMsid
				atOrBefore: eachInputWrapper record timestamp)
			from: scopeStartTimestamp
			to: scopeEndTimestamp.
		inputsByTime add: timeSeriesWrapper.
		metadataChanges
			add: timeSeriesWrapper;
			addAll: 
				(self 
					computeMetadataChangeForMetricId: timeSeriesWrapper metricId 
					resourceId: timeSeriesWrapper resourceId 
					between: scopeStartTimestamp 
					and: timeSeriesWrapper timestamp);
			add: eachInputWrapper].</body>

<body package="PV-DC-Recomputations" selector="recomputeAll:originLabel:">recomputeAll: aCollection originLabel: originLabel
	"Run recomputation using the given recomputation action."

	| recomputationRecords actions |
	self system extendedStatus: 'Running Recomputation'.
	recomputationRecords := self removeNonRecomputationRecordsFrom: aCollection.
	actions := self removeDuplicateRecordsFrom: recomputationRecords using: originLabel.

	actions doWithIndex: [:each :index |
		self system
			logDebugTwo: #RECOMP
			text: 'Processing recomp record: ', each printString, ' - ', index printString, ' of ', actions size printString].

	recomputationActions := self convertRecomputationActions: actions.
	recomputationActions isEmpty
		ifTrue: [^#(() ())].
	recomputationActions := recomputationActions asSortedCollection: [:a :b | a timestamp &lt;= b timestamp].

	deltas := OrderedCollection new.
	self affectedTimeSeriesDo: [:eachTimeSeries |
		self computeScopeFor: eachTimeSeries.
		scopeStartTimestamp notNil
			ifTrue: [
				self
					computeInputsFor: eachTimeSeries;
					computeMetadataChangesFor: eachTimeSeries;
					computeNonInputMetadataChangesFor: eachTimeSeries;
					gatherOriginalResultsFor: eachTimeSeries;
					gatherMetricsFor: eachTimeSeries passing: actions;
					runReplayFor: eachTimeSeries]].

	self switchDeltasUsing: recomputationRecords.
	self system extendedStatus: 'Done Recomputation'.
	^Array with: deltas with: recomputationRecords</body>

<body package="PV-DC-Recomputations" selector="computeInputsFor:">computeInputsFor: aTimeSeries
	"Determine what the inputs were to the formula the given time series represents."

	| wrapper toDelete |
	originalInputs := queryInterface 
		getLastInputsForTimeSeriesWithId: aTimeSeries msid 
		atOrBefore: scopeStartTimestamp.

	changedInputs := queryInterface
		getAllInputsForTimeSeriesWithId: aTimeSeries msid 
		between: scopeStartTimestamp
		and: scopeEndTimestamp.

	mergedInputs := SortedCollection sortBlock: [:a :b | 
		(a record resyncHistoricalDate &lt; b record resyncHistoricalDate) or: 
			[(a record resyncHistoricalDate = b record resyncHistoricalDate and: [a record inputTimeSeriesMsid &lt; b record inputTimeSeriesMsid])
				or: [a record resyncHistoricalDate = b record resyncHistoricalDate and: [a record inputTimeSeriesMsid = b record inputTimeSeriesMsid and: [(a record versionDate isNil or: [b record versionDate isNil]) or: [a record versionDate &lt; b record versionDate]]]]]].

	originalInputs do: [:each |
		wrapper := RecomputationAddInputWrapper
				on: each
				from: scopeStartTimestamp
				to: scopeEndTimestamp.
		mergedInputs add: wrapper].

	changedInputs do: [:each |
		wrapper := RecomputationAddInputWrapper
			on: each
			from: each timestamp
			to: scopeEndTimestamp.
		" Weed out plain dups here -- the queries above overlap by one second "
		(mergedInputs anySatisfy: [:eachInputWrapper | eachInputWrapper isSameAs: wrapper])
			ifFalse: [mergedInputs add: wrapper]].

	" Deal with input moves, etc "
	toDelete := OrderedCollection new.
	mergedInputs fold: [:prev :next |
		" Multiple simultaneous changes? "
		(prev record operatorTimeSeriesMsid = next record operatorTimeSeriesMsid
			and: [prev record inputTimeSeriesMsid = next record inputTimeSeriesMsid and: 
				[prev record resyncHistoricalDate = next record resyncHistoricalDate]])
			ifTrue: 
				[prev record versionDate = next record versionDate
					ifTrue: 
						[" Simultaneous change in the plan -- same version, must be time series move "
						prev record isActionDelete 
							ifTrue: [toDelete add: prev]
							ifFalse: 
								[next record isActionDelete 
									ifTrue: [toDelete add: next]]]
					ifFalse: [
						" next action is older version, leave just the last one "
						toDelete add: prev]
			].
		next
	].
	mergedInputs removeAll: toDelete.</body>

<body package="PV-DC-Recomputations" selector="gatherOriginalResultsFor:passing:">gatherOriginalResultsFor: aTimeSeries passing: recompActions
	"Retrieve the original metrics produced by the formula assocaited with the given time series, during the time periond in question."

	originalResults := queryInterface
		getMetricsForMid: aTimeSeries metricId
		rid: aTimeSeries resourceId
		between: scopeStartTimestamp
		and: scopeEndTimestamp
		passing: recompActions.</body>

<body package="PV-DC-Recomputations" selector="computeScopeFor:">computeScopeFor: aTimeSeries
	"Determine the scope of the receiver's operation, which involves finding the period of the formula the given time series represents, and then finding the boundaries of that period."

	| startScope endScope timeBlock |
	"Note - We have to do these in reverse order, because part of doing the scope calculation is to resync the formula itself into the model,
	and we need to end up with the original one in the model at the start time, not what was there at the end time..."
	endScope := queryInterface
		getScopeFor: aTimeSeries
		timestamp: recomputationActions last timestamp.
	endScope isNil
		ifTrue: [
			self system 
				logDebugTwo: #RECOMP_ERROR
				text: 'No inputs for time series ', aTimeSeries printString, ' at or before ', (PvTimestamp fromSeconds: recomputationActions last timestamp) printString.
			^nil].

	startScope := recomputationActions size = 1
		ifTrue: [endScope]
		ifFalse: [
			self pvModel calendarManager resetLocalizedSchedules.
			queryInterface
				getScopeFor: aTimeSeries
				timestamp: recomputationActions first timestamp].
	scopeStartTimestamp := startScope first key.
	scopeEndTimestamp := endScope first value.
	periodStartTimestamp := startScope last key.
	periodEndTimestamp := endScope last value.

	timeBlock := [:timestamp |
		(timestamp == Infinity positive) | (timestamp == Infinity negative)
			ifTrue: ['']
			ifFalse: [' (', (PvTimestamp fromSeconds: timestamp) printString, ')']].

	self system 
		logDebugTwo: #RECOMP_SCOPE
		text: ('Scope: %1%2 -&gt; %3%4'
			bindWith: scopeStartTimestamp printString
			with: (timeBlock value: scopeStartTimestamp)
			with: scopeEndTimestamp printString
			with: (timeBlock value: scopeEndTimestamp)).

	self system 
		logDebugTwo: #RECOMP_PERIOD
		text: ('Scope: %1%2 -&gt; %3%4'
			bindWith: periodStartTimestamp printString
			with: (timeBlock value: periodStartTimestamp)
			with: periodEndTimestamp printString
			with: (timeBlock value: periodEndTimestamp)).

	"Since we sometimes end up messing up localized schedules when we compute the scope, we need to reset them."
	self pvModel calendarManager resetLocalizedSchedules.</body>

<body package="PV-DC-Recomputations" selector="gatherMetricsFor:passing:">gatherMetricsFor: aTimeSeries passing: recompActions
	"Collect the set of metrics that were originally produced on all the inputs. Also, produce an updated list of metrics after applying the receiver's recomputation action to the original set."

	| metrics window |
	metrics := OrderedCollection new.
	window := queryInterface getWindowFor: aTimeSeries.
	inputsByTime do: [:eachTimeSeriesWrapper |
		| metricsForInput |
		metricsForInput := queryInterface
			getMetricsForMid: eachTimeSeriesWrapper metricId
			rid: eachTimeSeriesWrapper resourceId
			between: eachTimeSeriesWrapper startTimestamp
			and: eachTimeSeriesWrapper endTimestamp
			passing: recompActions.
		metricsForInput := self reduceInputMetrics: metricsForInput for: window.
		metrics add: metricsForInput].
	originalMetricsByTime := metrics
		inject: SortedCollection new
		into: [:sum :each |
			sum addAll: (each collect: [:eachSub | RecomputationMetricRecordWrapper on: eachSub]); yourself].
	updatedMetricsByTime := (originalMetricsByTime collect: [:each | each copy]) asSortedCollection.
	recomputationActions do: [:each | each applyTo: updatedMetricsByTime].

	self pvModel calendarManager resetLocalizedSchedules.

"	second := OrderedCollection new: updatedMetricsByTime size.
	updatedMetricsByTime do: [:each |
		| found |
		found := second
			detect: [:eachOther |
				each metricId = eachOther metricId
					and: [each resourceId = eachOther resourceId
					and: [each timestamp = eachOther timestamp]]]
			ifNone: [nil].
		found
			ifNil: [second add: each]
			ifNotNil: [:f | self halt]]."</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>private</category>

<body package="PV-DC-Recomputations" selector="updateFormula:from:for:">updateFormula: originalFormula from: updatedFormula for: aTimeSeries
	"Update the given original formula with the information from the updated one. Note that for formulas, we have to handle both the formula iteself as well as the formula prototype."

	| documentSource formulaSet latestFormula |

	[self pvModel formulaManager resyncFrom: updatedFormula] 
		on: Error 
		do: [:ex | 
			" The current scheme is crazy and no matter which order you try to do it, it produces an error
			The formula a) needs to be in formula manager
				b) has groups loaded and
				c) has to have the doc loaded
			This would at least accomplish adding it to formula manager, then grouping can succeed
			"
		nil].

	queryInterface resyncFormulaRelationshipsFor: updatedFormula id.
	self pvModel formulaManager buildNameIndex.
	documentSource := updatedFormula sourceText.

	documentSource isNil 
		ifTrue: [^self].

	formulaSet := self pvModel formulaManager documentRegistry
		loadDocumentNamed: documentSource
		timestamp: updatedFormula resyncHistoricalDate
		ifMissing: [^self].
	
	self pvModel formulaManager resyncFrom: updatedFormula.
	self pvModel resyncAgent commitResync.

	latestFormula := self pvModel formulaManager itemWithId: updatedFormula id.
	self
		doUpdateForComplexFormula: latestFormula
		withDoc: formulaSet
		at: latestFormula timestamp
		on: aTimeSeries.</body>

<body package="PV-DC-Recomputations" selector="doUpdateForComplexFormula:withDoc:at:on:">doUpdateForComplexFormula: aPvFormula withDoc: formulaSet at: timestamp on: timeSeries
	"Simulate a resync which includes a change of the PvFormula as refleced in the documentSource"

	| newFormula |
	self pvModel resyncAgent finalizeResync.
	newFormula := aPvFormula runCopy.
	newFormula
		resyncAction: #U;
		date: timestamp.

	"load the formula document with the same timestamp so that the lookup works properly"
	self pvModel formulaManager documentRegistry 
		registerFormulaSet: formulaSet 
		withTimestamp: timestamp.

	self pvModel formulaManager resyncFrom: newFormula.
	self pvModel resyncAgent commitResync.
	newFormula := self pvModel formulaManager itemWithId: newFormula id.
	queryInterface resyncFormulaArgumentsFor: newFormula.
	self pvModel resyncAgent commitResync.

	"We need to remove the heartbeat handler dependent for the old formula, since adding the time series will
		add a new dependency with the new version of the formula..."
	tupleRepository heartbeatHandlers do: [:each |
		each dependents asArray do: [:eachBroker |
			((eachBroker isKindOf: CMETimeSeries) and: [eachBroker formula isKindOf: LocalizedSchedule]) 
				ifFalse: 
					[eachBroker owner == aPvFormula formulaPrototype
						ifTrue: [each removeDependent: eachBroker]]]].

	" If the current formula changes, we need to re-shape it. We have to do this before we rebuild the rest because 
	code assumes time series inputs are consistent with formula arguments " 
	currentTimeSeries metricId = aPvFormula id
		ifTrue: 
			[self tupleRepository 
				atMsid: timeSeries msid 
				ifPresent: [:ts |
					self recompile: ts operator withFormula:  aPvFormula formulaPrototype]
				ifAbsent: []].
	self buildTimeSeriesFromCommand: timeSeries.</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>As yet unclassified</category>

<body package="PV-DC-Recomputations" selector="computeMetadataChangeForMetricId:resourceId:between:and:">computeMetadataChangeForMetricId: metricId resourceId: resourceId between: startTime and: endTime 
	"This method needs to figure out what metadata has changed for the given mid / rid, in the given scope.
	Non-input metadata changes can include formula definition changes, and subelement changes."
	
	|  formula changes |
	changes := OrderedCollection new.
	formula := pvModel formulaManager itemWithId: metricId.
	self dbSession 
		readObjectsOfClass: PvFormula
		with: 
			(PvFormula selectStatementWithParameters: 
				#startSeconds -&gt; startTime , (#endSeconds -&gt; endTime) , 
					(#id -&gt; metricId))
		into: 
			[:each | 
			changes add: 
				(RecomputationDbChangeWrapper 
					on: 
						(self 
							buildUpdateBlockForFormula: formula
							from: each)
					from: each timestamp
					to: endTime)].
	self dbSession 
		readObjectsOfClass: PvCmeSubelement
		with: 
			(PvCmeSubelement selectStatementWithParameters: 
				#startSeconds -&gt; startTime , (#endSeconds -&gt; endTime) , 
					(#id -&gt; resourceId))
		into: 
			[:each | 
			changes add: 
				(RecomputationDbChangeWrapper 
					on: (self buildUpdateBlockForSubelement: each)
					from: each timestamp
					to: endTime)].
	^changes</body>

<body package="PV-DC-Recomputations" selector="recompile:withFormula:">recompile: anOperator withFormula: aFormula 
	" Assume aTimeSeries is a Smee formula-based time series.
	Replace the prototype with the new formula and reshape the inputs "
	
	| oldInputs newInputs obsoleteInputs |
	oldInputs := anOperator inputs.
	newInputs := Array new: aFormula arguments size.
	" Get all the inputs that are preserved between in the new version of the formula and put them in proper place at the new inputs array"
	aFormula arguments keysAndValuesDo: 
		[:ix :eachArgument | 
		| oldInput |
		oldInput := 
			oldInputs 
				detect: [:eachInput | eachInput notNil and: [eachInput sequenceNumber = eachArgument id]]
				ifNone: [nil].
		oldInput ifNotNil: [newInputs at: ix put: oldInput]].

	" These inputs should have been deleted in an orderly fashion, so their presence may be an indication of some problem in the logic "
	obsoleteInputs := 
		oldInputs reject: 
			[:eachInput | 
			eachInput isNil 
				or: [aFormula arguments anySatisfy: [:eachArgument | eachInput sequenceNumber = eachArgument id]]].
	obsoleteInputs do: 
		[:eachInput | 
		self system 
			logWarning: #DISCONNECT_OBSOLETE_INPUT
			messageId: nil
			text: 
				'Disconnecting obsolete input on formula reshape. Time series ' , 
					anOperator printString , ', input: ' , eachInput printString.
		eachInput disconnect].
	anOperator smeePrototype: aFormula.
	anOperator inputs: newInputs</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>building</category>

<body package="PV-DC-Recomputations" selector="buildTimeSeriesFromCommand:">buildTimeSeriesFromCommand: command
	"Note - command must be an instance of PvTimeSeriesBuildCommand."
	
	| id action formula subelement |
	formula := self pvModel formulaOrLocalizedScheduleWithId: command metricId.
	formula isNil ifTrue: [
		self logMissingFormulaFromCommand: command.
		^self].
	formula formulaPrototype ifNotNil: [:formulaPrototype |
		formulaPrototype
			deduplicate: false;
			deduplicateIntermediate: false].
	self queryInterface resyncSubelementWithId: command resourceId.
	subelement := self pvModel resourceWithId: command resourceId.
	"There is a case when a SE gets deleted, PBL doesn't remove the time series until the start of the next hour. If we try and do recomp in that time interval, we can end up with nil instead of a valid SE. In this case, we can just ignore the time series..."
	subelement isNil
		ifTrue: [^self].

	self queryInterface resyncPropertiesFor: formula resource: subelement atOrBefore: scopeStartTimestamp.

	id := (MetricSeriesIdentifier 
		metric: formula
		resource: (self pvModel subelementManager itemWithId: command resourceId))
			msid: command msid;
			yourself.
	action := command resyncAction.
	" This is to cover test case scenarios where the actions comes as a symbol "
	((action isSymbol and: [action = #D]) or: [action = 'D']) 
		ifTrue: [self deleteTimeSeriesForId: id]
		ifFalse: ["add the timeseries if it isn't already there"
			self 
				addOrUpdateTimeSeriesForId: id
				fromCommand: command]</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>logging</category>

<body package="PV-DC-Recomputations" selector="logMissingFormulaFromCommand:">logMissingFormulaFromCommand: command

	self system 
		logWarning: #NO_FORMULA
		messageId: #DC10437
		template: 'No formula for: &lt;1p&gt;'
		arguments: (Array with: command)</body>
</methods>


<methods>
<class-id>PROVISO.RecompTupleInjectionInterface</class-id> <category>initialize-release</category>

<body package="PV-DC-Recomputations" selector="initialize">initialize
	
	super initialize.
	self agentQueue: (SharedPriorityQueue sortBlock: [:container1 :container2 | 
		container1 isForRecomputations 
			ifTrue: [
				container2 isForRecomputations 
					ifTrue: [container1 timestamp &lt; container2 timestamp]
					ifFalse: [true]]
				ifFalse: [
					container2 isForRecomputations 
						ifTrue: [false]
						ifFalse: [container1 timestamp &lt; container2 timestamp]]])</body>
</methods>


<methods>
<class-id>PROVISO.MockRecomputationQueryInterface</class-id> <category>queries</category>

<body package="PV-DC-Recomputations" selector="getMetricsForMid:rid:between:and:passing:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber passing: recompActions

	^metricsHistory select: [:each |
		each metricId = metricId
			and: [each resourceId = resourceId]
			and: [each timestamp between: startTsNumber and: endTsNumber]]</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationQueryInterface</class-id> <category>queries</category>

<body package="PV-DC-Recomputations" selector="isDuplicate:">isDuplicate: aRecompRecord

	| sql results |
	sql := 'select count(*) from MTRC00_SNRW_000_FULL where idx_metric = %1 and idx_resource = %2 and dte_date = %3 and dte_adj_date = %4 and idx_event = %5' bindWithArguments: { aRecompRecord metricId asString . aRecompRecord resourceId asString . aRecompRecord referenceDate asString . aRecompRecord date asString . aRecompRecord eventId asString }.
	results := self dbSession executeSelect: sql.
	^results isEmpty
		ifTrue: [false]
		ifFalse: [results first first &gt; 0]</body>

<body package="PV-DC-Recomputations" selector="getAllInputsForTimeSeriesWithId:between:and:">getAllInputsForTimeSeriesWithId: anMsid between: scopeStartTimestamp and: scopeEndTimestamp
	" Answer all latest inputs for the given time series between the two timestamps.
	We scan the whole history looking for all inputs for this time series , then group by each input's msid."
	
	| inputs |
	inputs := OrderedCollection new.
	self dbSession
		readObjectsOfClass: PvInputBuildCommand
		with: (PvInputBuildCommand selectStatementForAllForMsid: anMsid between: scopeStartTimestamp and: scopeEndTimestamp)
		into: [:each | inputs add: each].

	^inputs</body>

<body package="PV-DC-Recomputations" selector="getMetricsForMid:rid:between:and:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber 
	"Ask tuple storage for the set of metric records in the given timeframe, with the given mid/rid."
	
	^self getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber passing: #()</body>

<body package="PV-DC-Recomputations" selector="getMetricsForMid:rid:between:and:passing:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber passing: passingTuples
	"Ask tuple storage for the set of metric records in the given timeframe, with the given mid/rid."
	
	^self 
		queryTupleStorageWith: #getMetricsForMid:rid:between:and:adjTime:passing:
		arguments: 
			(Array 
				with: metricId
				with: resourceId
				with: (self encodeInfinity: startTsNumber)
				with: (self encodeInfinity: endTsNumber)
				with: '+infinity'
				with: passingTuples)</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationAddTimeSeriesWrapper</class-id> <category>replay</category>

<body package="PV-DC-Recomputations" selector="replayFor:on:">replayFor: aRecomputationEngine on: aTupleRepository
	"Apply the receiver's record to the tuple repository during a recompute..."

	aRecomputationEngine buildTimeSeriesFromCommand: self record.

	"We need to clean up spurious heartbeat brokers, because we are only interested
	in getting heartbeats to the current time series."
	aTupleRepository heartbeatHandlers do: [:each |
		each dependents asArray do: [:eachBroker |
			((eachBroker isKindOf: CMETimeSeries) and: [eachBroker formula isKindOf: LocalizedSchedule]) 
				ifFalse: [	eachBroker metricId = aRecomputationEngine currentTimeSeries metricId
					ifFalse: [each removeDependent: eachBroker]]]].</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationAddInputWrapper</class-id> <category>replay</category>

<body package="PV-DC-Recomputations" selector="replayFor:on:">replayFor: aRecomputationEngine on: aTupleRepository
	"Apply the receiver's record to the tuple repository during a recompute..."

	aRecomputationEngine buildInputFromCommand: self record.

	"We need to clean up spurious heartbeat brokers, because we are only interested
	in getting heartbeats to the current time series."
	aTupleRepository heartbeatHandlers do: [:each |
		each dependents asArray do: [:eachBroker |
			((eachBroker isKindOf: CMETimeSeries) and: [eachBroker formula isKindOf: LocalizedSchedule]) 
				ifFalse: 
					[eachBroker metricId = aRecomputationEngine currentTimeSeries metricId
						ifFalse: [each removeDependent: eachBroker]]]].</body>
</methods>



<methods>
<class-id>PROVISO.PvChannelManagerDbInterface</class-id> <category>stored procedures</category>

<body package="PV-CMG" selector="registerCurrentChannelsFor:">registerCurrentChannelsFor: aConfiguration 
	
	self dbSession doProtected:
		[self dbSession withSessionNoTimeoutDo: 
			[:session | 
			session connection begin.
	[aConfiguration do:[ :anArray|
		session prepare: 
			'INSERT INTO GTT_CHNL_COMPONENT_DESC (IDX_CHNL, IDX_SUBCHNL) VALUES(?,?)'.
		session bindInput: anArray.
	session
		execute].
session preparePLSQL: 'BEGIN ' , 'PV_ADMIN.Pvm_Dataload.Update_Subchnl_Config_Status; END;'.
	session
		execute.
	session connection commit] ifCurtailed: [session connection rollback]]]</body>
</methods>



<class>
<name>PvPblStateFileViewer</name>
<environment>PROVISO</environment>
<super>Tools.FileTools.FileContentsViewer</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Tools-File Browser</category>
<attributes>
<package>PV-Development Enhancements</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvPblStateFileViewer</class-id> <category>private</category>

<body package="PV-Development Enhancements" selector="textForEntireFile:">textForEntireFile: aFilename 
	
	^(PROVISO.SimpleSerializer forReading: aFilename asFilename readStream binary) read printString</body>

<body package="PV-Development Enhancements" selector="textForFileBeginning:">textForFileBeginning: aFilename 

	^self textForEntireFile: aFilename</body>

<body package="PV-Development Enhancements" selector="largeFileThreshold">largeFileThreshold
	"Files larges than this number of bytes are displayed in preview mode first."

	^10000</body>
</methods>


<methods>
<class-id>PROVISO.PvPblStateFileViewer class</class-id> <category>accessing</category>

<body package="PV-Development Enhancements" selector="tabPosition">tabPosition

	^2</body>

<body package="PV-Development Enhancements" selector="isInterestedInFile:">isInterestedInFile: aFilename 

	^#('versionBeingBuilt.state' 'versionLastBuilt.state' 'labelChangeHistory.state' 'aliasedCollectors.state' 'advanceCollectorRequests.state' 'operatorLabels.state' 'collectorLabels.state') includes: aFilename tail</body>

<body package="PV-Development Enhancements" selector="tabLabel">tabLabel

	^(self name &lt;&lt; #labels &gt;&gt; self name asString)</body>
</methods>



<methods>
<class-id>PROVISO.PvDiscoveryPipeline</class-id> <category>logging</category>

<body package="PV-Discovery-Core" selector="logProfileStucked">logProfileStucked
	
	self system 
		logWarning: #PROFILENOTPROGRESSING
		messageId: #DL39001
		text: self tag , '. Profile is not progressing during the last ' , self stuckTime asString, ' seconds, aborting ...'.</body>
</methods>



<methods>
<class-id>PROVISO.PvESFormulaEditor</class-id> <category>actions</category>

<body package="PV-CFL-UI" selector="buildComputation">buildComputation
	
	| treeBuilder |
	self validateBeforeBuild 
		ifFalse: 
			[self statusFailure: 'Formula not deployed'.
			^self].
	self results: OrderedCollection new.
	self removeBuildErrors.
	self resetTupleRepository.
	self environment do: 
		[treeBuilder := MockRequestEnumerator new.
		treeBuilder
			environment: Smee.SmeeEnvironment current;
			tupleRepository: self tupleRepository;
			shouldBuildRaAndGaBuckets: false;
			pvModel: self pvModel;
			collectorNumber: 1.
		treeBuilder associations: (Array with: self selectedFormula -&gt; self selectedSubelement).
		treeBuilder addDependent: self.
		[[treeBuilder build] 
			on: Error
			do: [:ex | ^Dialog notify: 'Fatal Build Error: ' , ex description]] 
				on: TreeBuildError
				do: 
					[:ex1 | 
					self addBuildError: ex1.
					ex1 resume]].
	self updateInputChoices.
	self updateStateOfTimeSeriesDependentControls.
	self statusSuccess: 
		'Ready for testing, click ''Show Tree'' at any time to see details'</body>
</methods>



<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>scheduling</category>

<body package="PVAdaptor-Schema" selector="scheduleMostRecentInputs">scheduleMostRecentInputs
	
	| scheduledAnything |
	scheduledAnything := false.
	self inputsByPeriodDo: 
		[:eachSet | 
		(self shouldBeProcessed: eachSet) 
			ifTrue: 
				[scheduledAnything := true.
				self processAll: eachSet]
			ifFalse: [^scheduledAnything]].
	^scheduledAnything</body>

<body package="PVAdaptor-Schema" selector="nextPeriodInputsFrom:">nextPeriodInputsFrom: inputStream 
	
	| begin result |
	begin := nil.
	result := OrderedCollection new.
	inputStream do: 
		[:each | 
		| periodStart |
		periodStart := self startOfPeriod: each.
		begin ifNil: [begin := periodStart].
		periodStart = begin 
			ifTrue: [result add: each]
			ifFalse: 
				[inputStream skip: -1.
				^result]].
	^result</body>
</methods>



<methods>
<class-id>PROVISO.UBA.UBAApplication</class-id> <category>initialization</category>

<body package="PVAdaptor-Application" selector="initializePvModel">initializePvModel
	
	self pvModel initializeForUBA.
	self testMode 
		ifFalse: 
			[self pvModel formulaManager shouldBuildSmalltalkFormulas: false.
			self pvModel
				idManager: nil;
				idManagerRU: nil;
				idManagerEvent: nil]</body>
</methods>


<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Application" selector="initializeForNGUBA">initializeForNGUBA
	
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvElementManager new.
	subelementManager := PvSubelementManager new.
	eventManager := PvEventManager new.
	eventPropertyManager := PvEventPropertyManager new.
	eventRelationManager := PvEventRelationManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvInventoryThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvPropertyManager new.
	relationManager := PvRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self initCollectorsByChannel.
	self loadStatsCollector: false.
	self pvModel formulaManager shouldBuildSmalltalkFormulas: false.</body>
</methods>



<methods>
<class-id>PROVISO.UBA.ModelAccessor</class-id> <category>private-metadat resync</category>

<body package="NGUBA-Application" selector="resetMetadataSelectors">resetMetadataSelectors
	
	metadataSelectors := #(elementManager subelementManager formulaManager propertyManager relationManager eventManager eventPropertyManager eventRelationManager)</body>
</methods>



</st-source>
